/* fuzzy-finder.c generated by valac 0.56.15, the Vala compiler
 * generated from fuzzy-finder.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2023 elementary, Inc. <https://elementary.io>
 *
 * Authored by: Marvin Ahlgrimm
 *              Colin Kiama <colinkiama@gmail.com>
 */

#include <glib.h>
#include "fuzzy-search.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>

#define SEPARATOR_BONUS 30
#define SEQUENTIAL_BONUS 40
#define CURRENT_PROJECT_PRIORITY_BONUS 40
#define CAMEL_BONUS 30
#define FIRST_LETTER_BONUS 15
#define LEADING_LETTER_PENALTY -5
#define MAX_LEADING_LETTER_PENALTY -15
#define UNMATCHED_LETTER_PENALTY -1
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _scratch_services_fuzzy_finder_unref0(var) ((var == NULL) ? NULL : (var = (scratch_services_fuzzy_finder_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _ScratchServicesFuzzyFinderFuzzyFindAsyncData ScratchServicesFuzzyFinderFuzzyFindAsyncData;
#define _scratch_services_search_project_unref0(var) ((var == NULL) ? NULL : (var = (scratch_services_search_project_unref (var), NULL)))
#define _search_result_unref0(var) ((var == NULL) ? NULL : (var = (search_result_unref (var), NULL)))

#define SCRATCH_SERVICES_FUZZY_FINDER_TYPE_RECURSIVE_FINDER (scratch_services_fuzzy_finder_recursive_finder_get_type ())
#define SCRATCH_SERVICES_FUZZY_FINDER_RECURSIVE_FINDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SCRATCH_SERVICES_FUZZY_FINDER_TYPE_RECURSIVE_FINDER, ScratchServicesFuzzyFinderRecursiveFinder))
#define SCRATCH_SERVICES_FUZZY_FINDER_RECURSIVE_FINDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SCRATCH_SERVICES_FUZZY_FINDER_TYPE_RECURSIVE_FINDER, ScratchServicesFuzzyFinderRecursiveFinderClass))
#define SCRATCH_SERVICES_FUZZY_FINDER_IS_RECURSIVE_FINDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SCRATCH_SERVICES_FUZZY_FINDER_TYPE_RECURSIVE_FINDER))
#define SCRATCH_SERVICES_FUZZY_FINDER_IS_RECURSIVE_FINDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SCRATCH_SERVICES_FUZZY_FINDER_TYPE_RECURSIVE_FINDER))
#define SCRATCH_SERVICES_FUZZY_FINDER_RECURSIVE_FINDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SCRATCH_SERVICES_FUZZY_FINDER_TYPE_RECURSIVE_FINDER, ScratchServicesFuzzyFinderRecursiveFinderClass))

typedef struct _ScratchServicesFuzzyFinderRecursiveFinder ScratchServicesFuzzyFinderRecursiveFinder;
typedef struct _ScratchServicesFuzzyFinderRecursiveFinderClass ScratchServicesFuzzyFinderRecursiveFinderClass;
#define _scratch_services_fuzzy_finder_recursive_finder_unref0(var) ((var == NULL) ? NULL : (var = (scratch_services_fuzzy_finder_recursive_finder_unref (var), NULL)))
typedef struct _ScratchServicesFuzzyFinderRecursiveFinderPrivate ScratchServicesFuzzyFinderRecursiveFinderPrivate;
typedef struct _ScratchServicesFuzzyFinderParamSpecRecursiveFinder ScratchServicesFuzzyFinderParamSpecRecursiveFinder;
typedef struct _ScratchServicesParamSpecFuzzyFinder ScratchServicesParamSpecFuzzyFinder;

struct _ScratchServicesFuzzyFinderPrivate {
	gint recursion_limit;
	gint max_matches;
	GeeHashMap* project_paths;
};

struct _Block2Data {
	int _ref_count_;
	ScratchServicesFuzzyFinder* self;
	GeeArrayList* results;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	gchar* search_str;
	guint dir_length;
	gchar* current_project;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _ScratchServicesFuzzyFinderFuzzyFindAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ScratchServicesFuzzyFinder* self;
	gchar* search_str;
	guint dir_length;
	gchar* current_project;
	GCancellable* cancellable;
	GeeArrayList* result;
	Block2Data* _data2_;
	GeeArrayList* _tmp0_;
	GThread* _tmp1_;
	GThread* _tmp2_;
	GeeArrayList* _tmp3_;
};

struct _ScratchServicesFuzzyFinderRecursiveFinder {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ScratchServicesFuzzyFinderRecursiveFinderPrivate * priv;
};

struct _ScratchServicesFuzzyFinderRecursiveFinderClass {
	GTypeClass parent_class;
	void (*finalize) (ScratchServicesFuzzyFinderRecursiveFinder *self);
};

struct _ScratchServicesFuzzyFinderRecursiveFinderPrivate {
	gint recursion_limit;
	gint max_matches;
	gint recursion_count;
};

struct _ScratchServicesFuzzyFinderParamSpecRecursiveFinder {
	GParamSpec parent_instance;
};

struct _ScratchServicesParamSpecFuzzyFinder {
	GParamSpec parent_instance;
};

static gint ScratchServicesFuzzyFinder_private_offset;
static gpointer scratch_services_fuzzy_finder_parent_class = NULL;
static gint ScratchServicesFuzzyFinderRecursiveFinder_private_offset;
static gpointer scratch_services_fuzzy_finder_recursive_finder_parent_class = NULL;
static GType scratch_services_fuzzy_finder_recursive_finder_type_id = 0;
static GType scratch_services_fuzzy_finder_type_id = 0;

static void scratch_services_fuzzy_finder_fuzzy_find_async_data_free (gpointer _data);
static gboolean scratch_services_fuzzy_finder_fuzzy_find_async_co (ScratchServicesFuzzyFinderFuzzyFindAsyncData* _data_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean _scratch_services_fuzzy_finder_fuzzy_find_async_co_gsource_func (gpointer self);
static void __lambda19_ (Block2Data* _data2_);
static gpointer ___lambda19__gthread_func (gpointer self);
static SearchResult* scratch_services_fuzzy_finder_fuzzy_match (ScratchServicesFuzzyFinder* self,
                                                         const gchar* pattern,
                                                         guint dir_length,
                                                         const gchar* str,
                                                         GCancellable* cancellable);
static gint __lambda20_ (ScratchServicesFuzzyFinder* self,
                  SearchResult* a,
                  SearchResult* b);
static gint ___lambda20__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static gpointer scratch_services_fuzzy_finder_recursive_finder_ref (gpointer instance);
static void scratch_services_fuzzy_finder_recursive_finder_unref (gpointer instance);
static GParamSpec* scratch_services_fuzzy_finder_param_spec_recursive_finder (const gchar* name,
                                                                       const gchar* nick,
                                                                       const gchar* blurb,
                                                                       GType object_type,
                                                                       GParamFlags flags) G_GNUC_UNUSED ;
static void scratch_services_fuzzy_finder_value_set_recursive_finder (GValue* value,
                                                               gpointer v_object) G_GNUC_UNUSED ;
static void scratch_services_fuzzy_finder_value_take_recursive_finder (GValue* value,
                                                                gpointer v_object) G_GNUC_UNUSED ;
static gpointer scratch_services_fuzzy_finder_value_get_recursive_finder (const GValue* value) G_GNUC_UNUSED ;
GType scratch_services_fuzzy_finder_recursive_finder_register_type (GTypeModule * module);
VALA_EXTERN GType scratch_services_fuzzy_finder_recursive_finder_get_type (void) G_GNUC_CONST ;
static ScratchServicesFuzzyFinderRecursiveFinder* scratch_services_fuzzy_finder_recursive_finder_new (gint limit,
                                                                                               gint mx_mtchs);
static ScratchServicesFuzzyFinderRecursiveFinder* scratch_services_fuzzy_finder_recursive_finder_construct (GType object_type,
                                                                                                     gint limit,
                                                                                                     gint mx_mtchs);
static SearchResult* scratch_services_fuzzy_finder_recursive_finder_fuzzy_match_recursive (ScratchServicesFuzzyFinderRecursiveFinder* self,
                                                                                    const gchar* pattern,
                                                                                    guint dir_length,
                                                                                    const gchar* str,
                                                                                    GCancellable* cancellable);
static gboolean scratch_services_fuzzy_finder_recursive_finder_limit_reached (ScratchServicesFuzzyFinderRecursiveFinder* self);
static SearchResult* scratch_services_fuzzy_finder_recursive_finder_fuzzy_match_recursive_internal (ScratchServicesFuzzyFinderRecursiveFinder* self,
                                                                                             const gchar* pattern,
                                                                                             guint dir_length,
                                                                                             const gchar* str,
                                                                                             gint pattern_current_index,
                                                                                             gint str_current_index,
                                                                                             gint next_match,
                                                                                             GCancellable* cancellable,
                                                                                             GeeArrayList* matches,
                                                                                             GeeArrayList* src_matches);
static void scratch_services_fuzzy_finder_recursive_finder_finalize (ScratchServicesFuzzyFinderRecursiveFinder * obj);
static void scratch_services_fuzzy_finder_finalize (ScratchServicesFuzzyFinder * obj);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
scratch_services_fuzzy_finder_get_instance_private (ScratchServicesFuzzyFinder* self)
{
	return G_STRUCT_MEMBER_P (self, ScratchServicesFuzzyFinder_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 210 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return self ? g_object_ref (self) : NULL;
#line 205 "fuzzy-finder.c"
}

ScratchServicesFuzzyFinder*
scratch_services_fuzzy_finder_construct (GType object_type,
                                         GeeHashMap* pps,
                                         gint limit,
                                         gint mx_mtchs)
{
	ScratchServicesFuzzyFinder* self = NULL;
	GeeHashMap* _tmp0_;
#line 207 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (pps != NULL, NULL);
#line 207 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self = (ScratchServicesFuzzyFinder*) g_type_create_instance (object_type);
#line 208 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self->priv->max_matches = mx_mtchs;
#line 209 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self->priv->recursion_limit = limit;
#line 210 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp0_ = _g_object_ref0 (pps);
#line 210 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_object_unref0 (self->priv->project_paths);
#line 210 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self->priv->project_paths = _tmp0_;
#line 207 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return self;
#line 232 "fuzzy-finder.c"
}

ScratchServicesFuzzyFinder*
scratch_services_fuzzy_finder_new (GeeHashMap* pps,
                                   gint limit,
                                   gint mx_mtchs)
{
#line 207 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return scratch_services_fuzzy_finder_construct (SCRATCH_SERVICES_TYPE_FUZZY_FINDER, pps, limit, mx_mtchs);
#line 242 "fuzzy-finder.c"
}

static void
scratch_services_fuzzy_finder_fuzzy_find_async_data_free (gpointer _data)
{
	ScratchServicesFuzzyFinderFuzzyFindAsyncData* _data_;
	_data_ = _data;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_object_unref0 (_data_->result);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_scratch_services_fuzzy_finder_unref0 (_data_->self);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_slice_free (ScratchServicesFuzzyFinderFuzzyFindAsyncData, _data_);
#line 256 "fuzzy-finder.c"
}

static gpointer
_scratch_services_fuzzy_finder_ref0 (gpointer self)
{
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return self ? scratch_services_fuzzy_finder_ref (self) : NULL;
#line 264 "fuzzy-finder.c"
}

void
scratch_services_fuzzy_finder_fuzzy_find_async (ScratchServicesFuzzyFinder* self,
                                                const gchar* search_str,
                                                guint dir_length,
                                                const gchar* current_project,
                                                GCancellable* cancellable,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	ScratchServicesFuzzyFinderFuzzyFindAsyncData* _data_;
	ScratchServicesFuzzyFinder* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_if_fail (self != NULL);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_if_fail (search_str != NULL);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_if_fail (current_project != NULL);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_if_fail (cancellable != NULL);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_ = g_slice_new0 (ScratchServicesFuzzyFinderFuzzyFindAsyncData);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_async_result = g_task_new (NULL, cancellable, _callback_, _user_data_);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_task_set_task_data (_data_->_async_result, _data_, scratch_services_fuzzy_finder_fuzzy_find_async_data_free);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp0_ = _scratch_services_fuzzy_finder_ref0 (self);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->self = _tmp0_;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp1_ = g_strdup (search_str);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_free0 (_data_->search_str);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->search_str = _tmp1_;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->dir_length = dir_length;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp2_ = g_strdup (current_project);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_free0 (_data_->current_project);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->current_project = _tmp2_;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->cancellable = _tmp3_;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	scratch_services_fuzzy_finder_fuzzy_find_async_co (_data_);
#line 321 "fuzzy-finder.c"
}

GeeArrayList*
scratch_services_fuzzy_finder_fuzzy_find_finish (ScratchServicesFuzzyFinder* self,
                                                 GAsyncResult* _res_)
{
	GeeArrayList* result;
	ScratchServicesFuzzyFinderFuzzyFindAsyncData* _data_;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (NULL == _data_) {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		return NULL;
#line 336 "fuzzy-finder.c"
	}
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	result = _data_->result;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->result = NULL;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return result;
#line 344 "fuzzy-finder.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return _data2_;
#line 354 "fuzzy-finder.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 364 "fuzzy-finder.c"
		ScratchServicesFuzzyFinder* self;
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
		self = _data2_->self;
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
		(_data2_->callback_target_destroy_notify == NULL) ? NULL : (_data2_->callback_target_destroy_notify (_data2_->callback_target), NULL);
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_data2_->callback = NULL;
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_data2_->callback_target = NULL;
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_data2_->callback_target_destroy_notify = NULL;
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_g_object_unref0 (_data2_->results);
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_g_free0 (_data2_->search_str);
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_g_free0 (_data2_->current_project);
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_g_object_unref0 (_data2_->cancellable);
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_scratch_services_fuzzy_finder_unref0 (self);
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
		g_slice_free (Block2Data, _data2_);
#line 388 "fuzzy-finder.c"
	}
}

static gboolean
_scratch_services_fuzzy_finder_fuzzy_find_async_co_gsource_func (gpointer self)
{
	gboolean result;
	result = scratch_services_fuzzy_finder_fuzzy_find_async_co (self);
#line 218 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return result;
#line 399 "fuzzy-finder.c"
}

static void
__lambda19_ (Block2Data* _data2_)
{
	ScratchServicesFuzzyFinder* self;
	GeeArrayList* _tmp0_;
	GSourceFunc _tmp1_;
	gpointer _tmp1__target;
	GDestroyNotify _tmp1__target_destroy_notify;
#line 219 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self = _data2_->self;
#line 220 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp0_ = scratch_services_fuzzy_finder_fuzzy_find (self, _data2_->search_str, _data2_->dir_length, _data2_->current_project, _data2_->cancellable);
#line 220 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_object_unref0 (_data2_->results);
#line 220 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data2_->results = _tmp0_;
#line 221 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp1_ = _data2_->callback;
#line 221 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp1__target = _data2_->callback_target;
#line 221 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp1__target_destroy_notify = _data2_->callback_target_destroy_notify;
#line 221 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data2_->callback = NULL;
#line 221 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data2_->callback_target = NULL;
#line 221 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data2_->callback_target_destroy_notify = NULL;
#line 221 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _tmp1_, _tmp1__target, _tmp1__target_destroy_notify);
#line 432 "fuzzy-finder.c"
}

static gpointer
___lambda19__gthread_func (gpointer self)
{
	gpointer result;
#line 219 "../plugins/fuzzy-search/fuzzy-finder.vala"
	__lambda19_ (self);
#line 441 "fuzzy-finder.c"
	result = NULL;
#line 219 "../plugins/fuzzy-search/fuzzy-finder.vala"
	block2_data_unref (self);
#line 219 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return result;
#line 447 "fuzzy-finder.c"
}

static gboolean
scratch_services_fuzzy_finder_fuzzy_find_async_co (ScratchServicesFuzzyFinderFuzzyFindAsyncData* _data_)
{
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	switch (_data_->_state_) {
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
		case 0:
#line 457 "fuzzy-finder.c"
		goto _state_0;
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
		case 1:
#line 461 "fuzzy-finder.c"
		goto _state_1;
		default:
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
		g_assert_not_reached ();
#line 466 "fuzzy-finder.c"
	}
	_state_0:
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_data2_ = g_slice_new0 (Block2Data);
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_data2_->_ref_count_ = 1;
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_data2_->self = scratch_services_fuzzy_finder_ref (_data_->self);
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_free0 (_data_->_data2_->search_str);
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_data2_->search_str = _data_->search_str;
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_data2_->dir_length = _data_->dir_length;
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_free0 (_data_->_data2_->current_project);
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_data2_->current_project = _data_->current_project;
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_object_unref0 (_data_->_data2_->cancellable);
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_data2_->cancellable = _data_->cancellable;
#line 213 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_data2_->_async_data_ = _data_;
#line 216 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_tmp0_ = gee_array_list_new (TYPE_SEARCH_RESULT, (GBoxedCopyFunc) search_result_ref, (GDestroyNotify) search_result_unref, NULL, NULL, NULL);
#line 216 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_data2_->results = _data_->_tmp0_;
#line 218 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_data2_->callback = _scratch_services_fuzzy_finder_fuzzy_find_async_co_gsource_func;
#line 218 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_data2_->callback_target = _data_;
#line 218 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_data2_->callback_target_destroy_notify = NULL;
#line 219 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_tmp1_ = g_thread_new ("fuzzy-find", ___lambda19__gthread_func, block2_data_ref (_data_->_data2_));
#line 219 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 219 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_thread_unref0 (_data_->_tmp2_);
#line 224 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_state_ = 1;
#line 224 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return FALSE;
#line 511 "fuzzy-finder.c"
	_state_1:
	;
#line 225 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_tmp3_ = _g_object_ref0 (_data_->_data2_->results);
#line 225 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->result = _data_->_tmp3_;
#line 225 "../plugins/fuzzy-search/fuzzy-finder.vala"
	block2_data_unref (_data_->_data2_);
#line 225 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_data_->_data2_ = NULL;
#line 225 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 225 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (_data_->_state_ != 0) {
#line 225 "../plugins/fuzzy-search/fuzzy-finder.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 225 "../plugins/fuzzy-search/fuzzy-finder.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 530 "fuzzy-finder.c"
		}
	}
#line 225 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_object_unref (_data_->_async_result);
#line 225 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return FALSE;
#line 537 "fuzzy-finder.c"
}

static gpointer
_scratch_services_search_project_ref0 (gpointer self)
{
#line 243 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return self ? scratch_services_search_project_ref (self) : NULL;
#line 545 "fuzzy-finder.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1581 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1582 "glib-2.0.vapi"
	result = self;
#line 1582 "glib-2.0.vapi"
	return result;
#line 558 "fuzzy-finder.c"
}

static gint
__lambda20_ (ScratchServicesFuzzyFinder* self,
             SearchResult* a,
             SearchResult* b)
{
	gint result;
#line 300 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 300 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 301 "../plugins/fuzzy-search/fuzzy-finder.vala"
	result = b->score - a->score;
#line 301 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return result;
#line 575 "fuzzy-finder.c"
}

static gint
___lambda20__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda20_ ((ScratchServicesFuzzyFinder*) self, (SearchResult*) a, (SearchResult*) b);
#line 300 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return result;
#line 587 "fuzzy-finder.c"
}

GeeArrayList*
scratch_services_fuzzy_finder_fuzzy_find (ScratchServicesFuzzyFinder* self,
                                          const gchar* search_str,
                                          guint dir_length,
                                          const gchar* current_project,
                                          GCancellable* cancellable)
{
	GeeArrayList* results = NULL;
	GeeArrayList* _tmp0_;
	ScratchServicesSearchProject** projects = NULL;
	GeeHashMap* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	gint _tmp5_ = 0;
	gpointer* _tmp6_;
	ScratchServicesSearchProject** _tmp7_;
	gint _tmp7__length1;
	gint projects_length1;
	gint _projects_size_;
	GeeArrayList* _tmp105_;
	GeeArrayList* _tmp106_;
	gint _tmp107_;
	gint _tmp108_;
	GeeArrayList* _tmp109_;
	GeeList* _tmp110_;
	GeeArrayList* result;
#line 228 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 228 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (search_str != NULL, NULL);
#line 228 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (current_project != NULL, NULL);
#line 228 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (cancellable != NULL, NULL);
#line 231 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp0_ = gee_array_list_new (TYPE_SEARCH_RESULT, (GBoxedCopyFunc) search_result_ref, (GDestroyNotify) search_result_unref, NULL, NULL, NULL);
#line 231 "../plugins/fuzzy-search/fuzzy-finder.vala"
	results = _tmp0_;
#line 232 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp1_ = self->priv->project_paths;
#line 232 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 232 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp3_ = _tmp2_;
#line 232 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp4_ = _tmp3_;
#line 232 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp6_ = gee_collection_to_array (_tmp4_, &_tmp5_);
#line 232 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp7_ = _tmp6_;
#line 232 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp7__length1 = _tmp5_;
#line 232 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_object_unref0 (_tmp4_);
#line 232 "../plugins/fuzzy-search/fuzzy-finder.vala"
	projects = _tmp7_;
#line 232 "../plugins/fuzzy-search/fuzzy-finder.vala"
	projects_length1 = _tmp7__length1;
#line 232 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_projects_size_ = projects_length1;
#line 651 "fuzzy-finder.c"
	{
		gint i = 0;
#line 234 "../plugins/fuzzy-search/fuzzy-finder.vala"
		i = 0;
#line 656 "fuzzy-finder.c"
		{
			gboolean _tmp8_ = FALSE;
#line 234 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp8_ = TRUE;
#line 234 "../plugins/fuzzy-search/fuzzy-finder.vala"
			while (TRUE) {
#line 663 "fuzzy-finder.c"
				ScratchServicesSearchProject** _tmp10_;
				gint _tmp10__length1;
				ScratchServicesSearchProject* project = NULL;
				ScratchServicesSearchProject** _tmp16_;
				gint _tmp16__length1;
				ScratchServicesSearchProject* _tmp17_;
				ScratchServicesSearchProject* _tmp18_;
#line 234 "../plugins/fuzzy-search/fuzzy-finder.vala"
				if (!_tmp8_) {
#line 673 "fuzzy-finder.c"
					gint _tmp9_;
#line 234 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp9_ = i;
#line 234 "../plugins/fuzzy-search/fuzzy-finder.vala"
					i = _tmp9_ + 1;
#line 679 "fuzzy-finder.c"
				}
#line 234 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp8_ = FALSE;
#line 234 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp10_ = projects;
#line 234 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp10__length1 = projects_length1;
#line 234 "../plugins/fuzzy-search/fuzzy-finder.vala"
				if (!(i < _tmp10__length1)) {
#line 234 "../plugins/fuzzy-search/fuzzy-finder.vala"
					break;
#line 691 "fuzzy-finder.c"
				}
#line 235 "../plugins/fuzzy-search/fuzzy-finder.vala"
				if (g_cancellable_is_cancelled (cancellable)) {
#line 695 "fuzzy-finder.c"
					GeeArrayList* _tmp11_;
					gint _tmp12_;
					gint _tmp13_;
					GeeArrayList* _tmp14_;
					GeeList* _tmp15_;
#line 236 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp11_ = results;
#line 236 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 236 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp13_ = _tmp12_;
#line 236 "../plugins/fuzzy-search/fuzzy-finder.vala"
					if (_tmp13_ <= 20) {
#line 237 "../plugins/fuzzy-search/fuzzy-finder.vala"
						result = results;
#line 237 "../plugins/fuzzy-search/fuzzy-finder.vala"
						projects = (_vala_array_free (projects, projects_length1, (GDestroyNotify) scratch_services_search_project_unref), NULL);
#line 237 "../plugins/fuzzy-search/fuzzy-finder.vala"
						return result;
#line 715 "fuzzy-finder.c"
					}
#line 240 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp14_ = results;
#line 240 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp15_ = gee_abstract_list_slice ((GeeAbstractList*) _tmp14_, 0, 20);
#line 240 "../plugins/fuzzy-search/fuzzy-finder.vala"
					result = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ARRAY_LIST, GeeArrayList);
#line 240 "../plugins/fuzzy-search/fuzzy-finder.vala"
					projects = (_vala_array_free (projects, projects_length1, (GDestroyNotify) scratch_services_search_project_unref), NULL);
#line 240 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_g_object_unref0 (results);
#line 240 "../plugins/fuzzy-search/fuzzy-finder.vala"
					return result;
#line 729 "fuzzy-finder.c"
				}
#line 243 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp16_ = projects;
#line 243 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp16__length1 = projects_length1;
#line 243 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp17_ = _tmp16_[i];
#line 243 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp18_ = _scratch_services_search_project_ref0 (_tmp17_);
#line 243 "../plugins/fuzzy-search/fuzzy-finder.vala"
				project = _tmp18_;
#line 741 "fuzzy-finder.c"
				{
					gint j = 0;
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
					j = 0;
#line 746 "fuzzy-finder.c"
					{
						gboolean _tmp19_ = FALSE;
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
						_tmp19_ = TRUE;
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
						while (TRUE) {
#line 753 "fuzzy-finder.c"
							ScratchServicesSearchProject* _tmp21_;
							GeeArrayList* _tmp22_;
							GeeArrayList* _tmp23_;
							gint _tmp24_;
							gint _tmp25_;
							gchar* path = NULL;
							ScratchServicesSearchProject* _tmp26_;
							GeeArrayList* _tmp27_;
							GeeArrayList* _tmp28_;
							gpointer _tmp29_;
							SearchResult* path_search_result = NULL;
							SearchResult* filename_search_result = NULL;
							gchar* project_name = NULL;
							gchar* _tmp30_;
							gchar* _tmp31_ = NULL;
							GeeHashMap* _tmp32_;
							gint _tmp33_;
							gint _tmp34_;
							gchar* _tmp40_;
							gboolean _tmp41_ = FALSE;
							gchar* root_path = NULL;
							ScratchServicesSearchProject* _tmp59_;
							const gchar* _tmp60_;
							const gchar* _tmp61_;
							gchar* _tmp62_;
							SearchResult* _tmp63_;
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
							if (!_tmp19_) {
#line 782 "fuzzy-finder.c"
								gint _tmp20_;
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp20_ = j;
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
								j = _tmp20_ + 1;
#line 788 "fuzzy-finder.c"
							}
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp19_ = FALSE;
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp21_ = project;
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp22_ = scratch_services_search_project_get_relative_file_paths (_tmp21_);
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp23_ = _tmp22_;
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp25_ = _tmp24_;
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
							if (!(j < _tmp25_)) {
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
								break;
#line 806 "fuzzy-finder.c"
							}
#line 246 "../plugins/fuzzy-search/fuzzy-finder.vala"
							if (g_cancellable_is_cancelled (cancellable)) {
#line 247 "../plugins/fuzzy-search/fuzzy-finder.vala"
								result = results;
#line 247 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_scratch_services_search_project_unref0 (project);
#line 247 "../plugins/fuzzy-search/fuzzy-finder.vala"
								projects = (_vala_array_free (projects, projects_length1, (GDestroyNotify) scratch_services_search_project_unref), NULL);
#line 247 "../plugins/fuzzy-search/fuzzy-finder.vala"
								return result;
#line 818 "fuzzy-finder.c"
							}
#line 250 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp26_ = project;
#line 250 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp27_ = scratch_services_search_project_get_relative_file_paths (_tmp26_);
#line 250 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp28_ = _tmp27_;
#line 250 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp29_ = gee_abstract_list_get ((GeeAbstractList*) _tmp28_, j);
#line 250 "../plugins/fuzzy-search/fuzzy-finder.vala"
							path = (gchar*) _tmp29_;
#line 259 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp30_ = g_strdup ("");
#line 259 "../plugins/fuzzy-search/fuzzy-finder.vala"
							project_name = _tmp30_;
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp32_ = self->priv->project_paths;
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp33_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp32_);
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp34_ = _tmp33_;
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
							if (_tmp34_ > 1) {
#line 842 "fuzzy-finder.c"
								ScratchServicesSearchProject* _tmp35_;
								const gchar* _tmp36_;
								const gchar* _tmp37_;
								gchar* _tmp38_;
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp35_ = project;
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp36_ = scratch_services_search_project_get_root_path (_tmp35_);
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp37_ = _tmp36_;
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp38_ = g_path_get_basename (_tmp37_);
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_g_free0 (_tmp31_);
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp31_ = _tmp38_;
#line 859 "fuzzy-finder.c"
							} else {
								gchar* _tmp39_;
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp39_ = g_strdup ("");
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_g_free0 (_tmp31_);
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp31_ = _tmp39_;
#line 868 "fuzzy-finder.c"
							}
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp40_ = g_strdup (_tmp31_);
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_g_free0 (project_name);
#line 261 "../plugins/fuzzy-search/fuzzy-finder.vala"
							project_name = _tmp40_;
#line 262 "../plugins/fuzzy-search/fuzzy-finder.vala"
							if (dir_length > ((guint) 0)) {
#line 262 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp41_ = TRUE;
#line 880 "fuzzy-finder.c"
							} else {
								GeeHashMap* _tmp42_;
								gint _tmp43_;
								gint _tmp44_;
#line 262 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp42_ = self->priv->project_paths;
#line 262 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp43_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp42_);
#line 262 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp44_ = _tmp43_;
#line 262 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp41_ = _tmp44_ == 1;
#line 893 "fuzzy-finder.c"
							}
#line 262 "../plugins/fuzzy-search/fuzzy-finder.vala"
							if (_tmp41_) {
#line 897 "fuzzy-finder.c"
								const gchar* _tmp45_;
								SearchResult* _tmp46_;
#line 263 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp45_ = path;
#line 263 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp46_ = scratch_services_fuzzy_finder_fuzzy_match (self, search_str, dir_length, _tmp45_, cancellable);
#line 263 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_search_result_unref0 (path_search_result);
#line 263 "../plugins/fuzzy-search/fuzzy-finder.vala"
								path_search_result = _tmp46_;
#line 908 "fuzzy-finder.c"
							} else {
								const gchar* _tmp47_;
								const gchar* _tmp48_;
								const gchar* _tmp49_;
								const gchar* _tmp50_;
								gchar* _tmp51_;
								gchar* _tmp52_;
								SearchResult* _tmp53_;
#line 265 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp47_ = project_name;
#line 265 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp48_ = string_to_string (_tmp47_);
#line 265 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp49_ = path;
#line 265 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp50_ = string_to_string (_tmp49_);
#line 265 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp51_ = g_strconcat (_tmp48_, "/", _tmp50_, NULL);
#line 265 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp52_ = _tmp51_;
#line 265 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp53_ = scratch_services_fuzzy_finder_fuzzy_match (self, search_str, dir_length, _tmp52_, cancellable);
#line 265 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_search_result_unref0 (path_search_result);
#line 265 "../plugins/fuzzy-search/fuzzy-finder.vala"
								path_search_result = _tmp53_;
#line 265 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_g_free0 (_tmp52_);
#line 937 "fuzzy-finder.c"
							}
#line 268 "../plugins/fuzzy-search/fuzzy-finder.vala"
							if (dir_length == ((guint) 0)) {
#line 941 "fuzzy-finder.c"
								gchar* filename = NULL;
								const gchar* _tmp54_;
								gchar* _tmp55_;
								const gchar* _tmp56_;
								SearchResult* _tmp57_;
#line 269 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp54_ = path;
#line 269 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp55_ = g_path_get_basename (_tmp54_);
#line 269 "../plugins/fuzzy-search/fuzzy-finder.vala"
								filename = _tmp55_;
#line 270 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp56_ = filename;
#line 270 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp57_ = scratch_services_fuzzy_finder_fuzzy_match (self, search_str, dir_length, _tmp56_, cancellable);
#line 270 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_search_result_unref0 (filename_search_result);
#line 270 "../plugins/fuzzy-search/fuzzy-finder.vala"
								filename_search_result = _tmp57_;
#line 268 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_g_free0 (filename);
#line 963 "fuzzy-finder.c"
							} else {
								SearchResult* _tmp58_;
#line 272 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp58_ = search_result_new (FALSE, 0);
#line 272 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_search_result_unref0 (filename_search_result);
#line 272 "../plugins/fuzzy-search/fuzzy-finder.vala"
								filename_search_result = _tmp58_;
#line 972 "fuzzy-finder.c"
							}
#line 275 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp59_ = project;
#line 275 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp60_ = scratch_services_search_project_get_root_path (_tmp59_);
#line 275 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp61_ = _tmp60_;
#line 275 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp62_ = g_strdup (_tmp61_);
#line 275 "../plugins/fuzzy-search/fuzzy-finder.vala"
							root_path = _tmp62_;
#line 277 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp63_ = filename_search_result;
#line 277 "../plugins/fuzzy-search/fuzzy-finder.vala"
							if (_tmp63_->found) {
#line 988 "fuzzy-finder.c"
								SearchResult* _tmp64_;
								const gchar* _tmp65_;
								gchar* _tmp66_;
								SearchResult* _tmp67_;
								const gchar* _tmp68_;
								const gchar* _tmp69_;
								const gchar* _tmp70_;
								const gchar* _tmp71_;
								gchar* _tmp72_;
								SearchResult* _tmp73_;
								const gchar* _tmp74_;
								gchar* _tmp75_;
								gint _tmp76_ = 0;
								ScratchServicesSearchProject* _tmp77_;
								const gchar* _tmp78_;
								const gchar* _tmp79_;
								SearchResult* _tmp80_;
								SearchResult* _tmp81_;
								GeeArrayList* _tmp82_;
								SearchResult* _tmp83_;
#line 278 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp64_ = filename_search_result;
#line 278 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp65_ = path;
#line 278 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp66_ = g_strdup (_tmp65_);
#line 278 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_g_free0 (_tmp64_->relative_path);
#line 278 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp64_->relative_path = _tmp66_;
#line 279 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp67_ = filename_search_result;
#line 279 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp68_ = root_path;
#line 279 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp69_ = string_to_string (_tmp68_);
#line 279 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp70_ = path;
#line 279 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp71_ = string_to_string (_tmp70_);
#line 279 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp72_ = g_strconcat (_tmp69_, "/", _tmp71_, NULL);
#line 279 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_g_free0 (_tmp67_->full_path);
#line 279 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp67_->full_path = _tmp72_;
#line 280 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp73_ = filename_search_result;
#line 280 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp74_ = project_name;
#line 280 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp75_ = g_strdup (_tmp74_);
#line 280 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_g_free0 (_tmp73_->project);
#line 280 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp73_->project = _tmp75_;
#line 281 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp77_ = project;
#line 281 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp78_ = scratch_services_search_project_get_root_path (_tmp77_);
#line 281 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp79_ = _tmp78_;
#line 281 "../plugins/fuzzy-search/fuzzy-finder.vala"
								if (g_strcmp0 (_tmp79_, current_project) == 0) {
#line 282 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp76_ = CURRENT_PROJECT_PRIORITY_BONUS;
#line 1055 "fuzzy-finder.c"
								} else {
#line 283 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp76_ = 0;
#line 1059 "fuzzy-finder.c"
								}
#line 281 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp80_ = filename_search_result;
#line 281 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp81_ = filename_search_result;
#line 281 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp81_->score = _tmp81_->score + _tmp76_;
#line 285 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp82_ = results;
#line 285 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp83_ = filename_search_result;
#line 285 "../plugins/fuzzy-search/fuzzy-finder.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp82_, _tmp83_);
#line 1073 "fuzzy-finder.c"
							} else {
								SearchResult* _tmp84_;
#line 286 "../plugins/fuzzy-search/fuzzy-finder.vala"
								_tmp84_ = path_search_result;
#line 286 "../plugins/fuzzy-search/fuzzy-finder.vala"
								if (_tmp84_->found) {
#line 1080 "fuzzy-finder.c"
									SearchResult* _tmp85_;
									const gchar* _tmp86_;
									gchar* _tmp87_;
									SearchResult* _tmp88_;
									const gchar* _tmp89_;
									const gchar* _tmp90_;
									const gchar* _tmp91_;
									const gchar* _tmp92_;
									gchar* _tmp93_;
									SearchResult* _tmp94_;
									const gchar* _tmp95_;
									gchar* _tmp96_;
									gint _tmp97_ = 0;
									ScratchServicesSearchProject* _tmp98_;
									const gchar* _tmp99_;
									const gchar* _tmp100_;
									SearchResult* _tmp101_;
									SearchResult* _tmp102_;
									GeeArrayList* _tmp103_;
									SearchResult* _tmp104_;
#line 287 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp85_ = path_search_result;
#line 287 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp86_ = path;
#line 287 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp87_ = g_strdup (_tmp86_);
#line 287 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_g_free0 (_tmp85_->relative_path);
#line 287 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp85_->relative_path = _tmp87_;
#line 288 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp88_ = path_search_result;
#line 288 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp89_ = root_path;
#line 288 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp90_ = string_to_string (_tmp89_);
#line 288 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp91_ = path;
#line 288 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp92_ = string_to_string (_tmp91_);
#line 288 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp93_ = g_strconcat (_tmp90_, "/", _tmp92_, NULL);
#line 288 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_g_free0 (_tmp88_->full_path);
#line 288 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp88_->full_path = _tmp93_;
#line 289 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp94_ = path_search_result;
#line 289 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp95_ = project_name;
#line 289 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp96_ = g_strdup (_tmp95_);
#line 289 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_g_free0 (_tmp94_->project);
#line 289 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp94_->project = _tmp96_;
#line 291 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp98_ = project;
#line 291 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp99_ = scratch_services_search_project_get_root_path (_tmp98_);
#line 291 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp100_ = _tmp99_;
#line 291 "../plugins/fuzzy-search/fuzzy-finder.vala"
									if (g_strcmp0 (_tmp100_, current_project) == 0) {
#line 292 "../plugins/fuzzy-search/fuzzy-finder.vala"
										_tmp97_ = CURRENT_PROJECT_PRIORITY_BONUS;
#line 1147 "fuzzy-finder.c"
									} else {
#line 293 "../plugins/fuzzy-search/fuzzy-finder.vala"
										_tmp97_ = 0;
#line 1151 "fuzzy-finder.c"
									}
#line 290 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp101_ = path_search_result;
#line 290 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp102_ = path_search_result;
#line 290 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp101_->score = ((gint) (_tmp102_->score * 0.2)) + _tmp97_;
#line 295 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp103_ = results;
#line 295 "../plugins/fuzzy-search/fuzzy-finder.vala"
									_tmp104_ = path_search_result;
#line 295 "../plugins/fuzzy-search/fuzzy-finder.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp103_, _tmp104_);
#line 1165 "fuzzy-finder.c"
								}
							}
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_g_free0 (root_path);
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_g_free0 (_tmp31_);
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_g_free0 (project_name);
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_search_result_unref0 (filename_search_result);
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_search_result_unref0 (path_search_result);
#line 245 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_g_free0 (path);
#line 1180 "fuzzy-finder.c"
						}
					}
				}
#line 234 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_scratch_services_search_project_unref0 (project);
#line 1186 "fuzzy-finder.c"
			}
		}
	}
#line 300 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp105_ = results;
#line 300 "../plugins/fuzzy-search/fuzzy-finder.vala"
	gee_list_sort ((GeeList*) _tmp105_, ___lambda20__gcompare_data_func, scratch_services_fuzzy_finder_ref (self), scratch_services_fuzzy_finder_unref);
#line 304 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp106_ = results;
#line 304 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp107_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp106_);
#line 304 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp108_ = _tmp107_;
#line 304 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (_tmp108_ <= 20) {
#line 305 "../plugins/fuzzy-search/fuzzy-finder.vala"
		result = results;
#line 305 "../plugins/fuzzy-search/fuzzy-finder.vala"
		projects = (_vala_array_free (projects, projects_length1, (GDestroyNotify) scratch_services_search_project_unref), NULL);
#line 305 "../plugins/fuzzy-search/fuzzy-finder.vala"
		return result;
#line 1208 "fuzzy-finder.c"
	}
#line 308 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp109_ = results;
#line 308 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp110_ = gee_abstract_list_slice ((GeeAbstractList*) _tmp109_, 0, 20);
#line 308 "../plugins/fuzzy-search/fuzzy-finder.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp110_, GEE_TYPE_ARRAY_LIST, GeeArrayList);
#line 308 "../plugins/fuzzy-search/fuzzy-finder.vala"
	projects = (_vala_array_free (projects, projects_length1, (GDestroyNotify) scratch_services_search_project_unref), NULL);
#line 308 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_object_unref0 (results);
#line 308 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return result;
#line 1222 "fuzzy-finder.c"
}

static SearchResult*
scratch_services_fuzzy_finder_fuzzy_match (ScratchServicesFuzzyFinder* self,
                                           const gchar* pattern,
                                           guint dir_length,
                                           const gchar* str,
                                           GCancellable* cancellable)
{
	ScratchServicesFuzzyFinderRecursiveFinder* finder = NULL;
	ScratchServicesFuzzyFinderRecursiveFinder* _tmp0_;
	SearchResult* _tmp1_;
	SearchResult* result;
#line 311 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 311 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (pattern != NULL, NULL);
#line 311 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 311 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (cancellable != NULL, NULL);
#line 312 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp0_ = scratch_services_fuzzy_finder_recursive_finder_new (self->priv->recursion_limit, self->priv->max_matches);
#line 312 "../plugins/fuzzy-search/fuzzy-finder.vala"
	finder = _tmp0_;
#line 313 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp1_ = scratch_services_fuzzy_finder_recursive_finder_fuzzy_match_recursive (finder, pattern, dir_length, str, cancellable);
#line 313 "../plugins/fuzzy-search/fuzzy-finder.vala"
	result = _tmp1_;
#line 313 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_scratch_services_fuzzy_finder_recursive_finder_unref0 (finder);
#line 313 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return result;
#line 1256 "fuzzy-finder.c"
}

static inline gpointer
scratch_services_fuzzy_finder_recursive_finder_get_instance_private (ScratchServicesFuzzyFinderRecursiveFinder* self)
{
	return G_STRUCT_MEMBER_P (self, ScratchServicesFuzzyFinderRecursiveFinder_private_offset);
}

static ScratchServicesFuzzyFinderRecursiveFinder*
scratch_services_fuzzy_finder_recursive_finder_construct (GType object_type,
                                                          gint limit,
                                                          gint mx_mtchs)
{
	ScratchServicesFuzzyFinderRecursiveFinder* self = NULL;
#line 24 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self = (ScratchServicesFuzzyFinderRecursiveFinder*) g_type_create_instance (object_type);
#line 25 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self->priv->recursion_limit = limit;
#line 26 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self->priv->max_matches = mx_mtchs;
#line 27 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self->priv->recursion_count = 0;
#line 24 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return self;
#line 1281 "fuzzy-finder.c"
}

static ScratchServicesFuzzyFinderRecursiveFinder*
scratch_services_fuzzy_finder_recursive_finder_new (gint limit,
                                                    gint mx_mtchs)
{
#line 24 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return scratch_services_fuzzy_finder_recursive_finder_construct (SCRATCH_SERVICES_FUZZY_FINDER_TYPE_RECURSIVE_FINDER, limit, mx_mtchs);
#line 1290 "fuzzy-finder.c"
}

static gboolean
scratch_services_fuzzy_finder_recursive_finder_limit_reached (ScratchServicesFuzzyFinderRecursiveFinder* self)
{
	gboolean result;
#line 30 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../plugins/fuzzy-search/fuzzy-finder.vala"
	result = self->priv->recursion_count >= self->priv->recursion_limit;
#line 31 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return result;
#line 1303 "fuzzy-finder.c"
}

static SearchResult*
scratch_services_fuzzy_finder_recursive_finder_fuzzy_match_recursive (ScratchServicesFuzzyFinderRecursiveFinder* self,
                                                                      const gchar* pattern,
                                                                      guint dir_length,
                                                                      const gchar* str,
                                                                      GCancellable* cancellable)
{
	GeeArrayList* matches = NULL;
	GeeArrayList* _tmp0_;
	SearchResult* _tmp1_;
	SearchResult* result;
#line 34 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (pattern != NULL, NULL);
#line 34 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 34 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (cancellable != NULL, NULL);
#line 35 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL);
#line 35 "../plugins/fuzzy-search/fuzzy-finder.vala"
	matches = _tmp0_;
#line 36 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp1_ = scratch_services_fuzzy_finder_recursive_finder_fuzzy_match_recursive_internal (self, pattern, dir_length, str, 0, 0, 0, cancellable, matches, NULL);
#line 36 "../plugins/fuzzy-search/fuzzy-finder.vala"
	result = _tmp1_;
#line 36 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_object_unref0 (matches);
#line 36 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return result;
#line 1337 "fuzzy-finder.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1270 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1271 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1271 "glib-2.0.vapi"
	return result;
#line 1351 "fuzzy-finder.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 1368 "fuzzy-finder.c"
}

static SearchResult*
scratch_services_fuzzy_finder_recursive_finder_fuzzy_match_recursive_internal (ScratchServicesFuzzyFinderRecursiveFinder* self,
                                                                               const gchar* pattern,
                                                                               guint dir_length,
                                                                               const gchar* str,
                                                                               gint pattern_current_index,
                                                                               gint str_current_index,
                                                                               gint next_match,
                                                                               GCancellable* cancellable,
                                                                               GeeArrayList* matches,
                                                                               GeeArrayList* src_matches)
{
	gint out_score = 0;
	gboolean recursive_match = FALSE;
	GeeArrayList* best_recursive_matches = NULL;
	GeeArrayList* _tmp0_;
	gint best_recursive_score = 0;
	gboolean first_match = FALSE;
	gboolean allowed_separators = FALSE;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_;
	gint _tmp6_;
	gboolean matched = FALSE;
	gint _tmp37_;
	gint _tmp38_;
	SearchResult* _tmp57_;
	SearchResult* result;
#line 39 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (pattern != NULL, NULL);
#line 39 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 39 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (cancellable != NULL, NULL);
#line 39 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (matches != NULL, NULL);
#line 48 "../plugins/fuzzy-search/fuzzy-finder.vala"
	out_score = 0;
#line 50 "../plugins/fuzzy-search/fuzzy-finder.vala"
	recursive_match = FALSE;
#line 51 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL);
#line 51 "../plugins/fuzzy-search/fuzzy-finder.vala"
	best_recursive_matches = _tmp0_;
#line 52 "../plugins/fuzzy-search/fuzzy-finder.vala"
	best_recursive_score = 0;
#line 54 "../plugins/fuzzy-search/fuzzy-finder.vala"
	first_match = TRUE;
#line 55 "../plugins/fuzzy-search/fuzzy-finder.vala"
	allowed_separators = TRUE;
#line 56 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp1_ = self->priv->recursion_count;
#line 56 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self->priv->recursion_count = _tmp1_ + 1;
#line 57 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (g_cancellable_is_cancelled (cancellable)) {
#line 57 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_tmp2_ = TRUE;
#line 1432 "fuzzy-finder.c"
	} else {
#line 57 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_tmp2_ = scratch_services_fuzzy_finder_recursive_finder_limit_reached (self);
#line 1436 "fuzzy-finder.c"
	}
#line 57 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (_tmp2_) {
#line 1440 "fuzzy-finder.c"
		SearchResult* _tmp3_;
#line 58 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_tmp3_ = search_result_new (FALSE, out_score);
#line 58 "../plugins/fuzzy-search/fuzzy-finder.vala"
		result = _tmp3_;
#line 58 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_g_object_unref0 (best_recursive_matches);
#line 58 "../plugins/fuzzy-search/fuzzy-finder.vala"
		return result;
#line 1450 "fuzzy-finder.c"
	}
#line 62 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp5_ = strlen (pattern);
#line 62 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp6_ = _tmp5_;
#line 62 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (pattern_current_index == _tmp6_) {
#line 62 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_tmp4_ = TRUE;
#line 1460 "fuzzy-finder.c"
	} else {
		gint _tmp7_;
		gint _tmp8_;
#line 62 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_tmp7_ = strlen (str);
#line 62 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_tmp8_ = _tmp7_;
#line 62 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_tmp4_ = str_current_index == _tmp8_;
#line 1470 "fuzzy-finder.c"
	}
#line 62 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (_tmp4_) {
#line 1474 "fuzzy-finder.c"
		SearchResult* _tmp9_;
#line 63 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_tmp9_ = search_result_new (FALSE, out_score);
#line 63 "../plugins/fuzzy-search/fuzzy-finder.vala"
		result = _tmp9_;
#line 63 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_g_object_unref0 (best_recursive_matches);
#line 63 "../plugins/fuzzy-search/fuzzy-finder.vala"
		return result;
#line 1484 "fuzzy-finder.c"
	}
#line 66 "../plugins/fuzzy-search/fuzzy-finder.vala"
	while (TRUE) {
#line 1488 "fuzzy-finder.c"
		gboolean _tmp10_ = FALSE;
		gint _tmp11_;
		gint _tmp12_;
		gunichar lower_case_char = 0U;
		gunichar lower_case_str_char = 0U;
		gint _tmp36_;
#line 66 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_tmp11_ = strlen (pattern);
#line 66 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_tmp12_ = _tmp11_;
#line 66 "../plugins/fuzzy-search/fuzzy-finder.vala"
		if (pattern_current_index < _tmp12_) {
#line 1501 "fuzzy-finder.c"
			gint _tmp13_;
			gint _tmp14_;
#line 66 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp13_ = strlen (str);
#line 66 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp14_ = _tmp13_;
#line 66 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp10_ = str_current_index < _tmp14_;
#line 1510 "fuzzy-finder.c"
		} else {
#line 66 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp10_ = FALSE;
#line 1514 "fuzzy-finder.c"
		}
#line 66 "../plugins/fuzzy-search/fuzzy-finder.vala"
		if (!_tmp10_) {
#line 66 "../plugins/fuzzy-search/fuzzy-finder.vala"
			break;
#line 1520 "fuzzy-finder.c"
		}
#line 67 "../plugins/fuzzy-search/fuzzy-finder.vala"
		if (g_cancellable_is_cancelled (cancellable)) {
#line 1524 "fuzzy-finder.c"
			SearchResult* _tmp15_;
#line 68 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp15_ = search_result_new (FALSE, out_score);
#line 68 "../plugins/fuzzy-search/fuzzy-finder.vala"
			result = _tmp15_;
#line 68 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_g_object_unref0 (best_recursive_matches);
#line 68 "../plugins/fuzzy-search/fuzzy-finder.vala"
			return result;
#line 1534 "fuzzy-finder.c"
		}
#line 71 "../plugins/fuzzy-search/fuzzy-finder.vala"
		lower_case_char = g_unichar_tolower (string_get_char (pattern, (glong) pattern_current_index));
#line 72 "../plugins/fuzzy-search/fuzzy-finder.vala"
		lower_case_str_char = g_unichar_tolower (string_get_char (str, (glong) str_current_index));
#line 76 "../plugins/fuzzy-search/fuzzy-finder.vala"
		if (lower_case_char == lower_case_str_char) {
#line 1542 "fuzzy-finder.c"
			gboolean _tmp16_ = FALSE;
			gboolean _tmp19_ = FALSE;
			GeeArrayList* recursive_matches = NULL;
			GeeArrayList* _tmp20_;
			SearchResult* recursive_result_search = NULL;
			GeeArrayList* _tmp21_;
			SearchResult* _tmp22_;
			SearchResult* _tmp23_;
			gint _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			gint _tmp33_;
#line 78 "../plugins/fuzzy-search/fuzzy-finder.vala"
			if (dir_length > ((guint) 0)) {
#line 78 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp16_ = pattern_current_index == 0;
#line 1559 "fuzzy-finder.c"
			} else {
#line 78 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp16_ = FALSE;
#line 1563 "fuzzy-finder.c"
			}
#line 78 "../plugins/fuzzy-search/fuzzy-finder.vala"
			if (_tmp16_) {
#line 1567 "fuzzy-finder.c"
				gboolean _tmp17_ = FALSE;
#line 79 "../plugins/fuzzy-search/fuzzy-finder.vala"
				if (str_current_index > 0) {
#line 79 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp17_ = g_unichar_tolower (string_get_char (str, (glong) (str_current_index - 1))) != ((gunichar) G_DIR_SEPARATOR);
#line 1573 "fuzzy-finder.c"
				} else {
#line 79 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp17_ = FALSE;
#line 1577 "fuzzy-finder.c"
				}
#line 79 "../plugins/fuzzy-search/fuzzy-finder.vala"
				if (_tmp17_) {
#line 80 "../plugins/fuzzy-search/fuzzy-finder.vala"
					break;
#line 1583 "fuzzy-finder.c"
				}
			}
#line 84 "../plugins/fuzzy-search/fuzzy-finder.vala"
			allowed_separators = FALSE;
#line 85 "../plugins/fuzzy-search/fuzzy-finder.vala"
			if (next_match >= self->priv->max_matches) {
#line 1590 "fuzzy-finder.c"
				SearchResult* _tmp18_;
#line 86 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp18_ = search_result_new (FALSE, out_score);
#line 86 "../plugins/fuzzy-search/fuzzy-finder.vala"
				result = _tmp18_;
#line 86 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_g_object_unref0 (best_recursive_matches);
#line 86 "../plugins/fuzzy-search/fuzzy-finder.vala"
				return result;
#line 1600 "fuzzy-finder.c"
			}
#line 89 "../plugins/fuzzy-search/fuzzy-finder.vala"
			if (first_match) {
#line 89 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp19_ = src_matches != NULL;
#line 1606 "fuzzy-finder.c"
			} else {
#line 89 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp19_ = FALSE;
#line 1610 "fuzzy-finder.c"
			}
#line 89 "../plugins/fuzzy-search/fuzzy-finder.vala"
			if (_tmp19_) {
#line 90 "../plugins/fuzzy-search/fuzzy-finder.vala"
				gee_abstract_collection_clear ((GeeAbstractCollection*) matches);
#line 91 "../plugins/fuzzy-search/fuzzy-finder.vala"
				gee_list_insert_all ((GeeList*) matches, 0, (GeeCollection*) src_matches);
#line 92 "../plugins/fuzzy-search/fuzzy-finder.vala"
				first_match = FALSE;
#line 1620 "fuzzy-finder.c"
			}
#line 95 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp20_ = gee_array_list_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL);
#line 95 "../plugins/fuzzy-search/fuzzy-finder.vala"
			recursive_matches = _tmp20_;
#line 96 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp21_ = recursive_matches;
#line 96 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp22_ = scratch_services_fuzzy_finder_recursive_finder_fuzzy_match_recursive_internal (self, pattern, dir_length, str, pattern_current_index, str_current_index + 1, next_match, cancellable, _tmp21_, matches);
#line 96 "../plugins/fuzzy-search/fuzzy-finder.vala"
			recursive_result_search = _tmp22_;
#line 108 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp23_ = recursive_result_search;
#line 108 "../plugins/fuzzy-search/fuzzy-finder.vala"
			if (_tmp23_->found) {
#line 1636 "fuzzy-finder.c"
				gboolean _tmp24_ = FALSE;
#line 110 "../plugins/fuzzy-search/fuzzy-finder.vala"
				if (!recursive_match) {
#line 110 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp24_ = TRUE;
#line 1642 "fuzzy-finder.c"
				} else {
					SearchResult* _tmp25_;
#line 110 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp25_ = recursive_result_search;
#line 110 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp24_ = _tmp25_->score > best_recursive_score;
#line 1649 "fuzzy-finder.c"
				}
#line 110 "../plugins/fuzzy-search/fuzzy-finder.vala"
				if (_tmp24_) {
#line 1653 "fuzzy-finder.c"
					GeeArrayList* _tmp26_;
					GeeArrayList* _tmp27_;
					GeeArrayList* _tmp28_;
					SearchResult* _tmp29_;
#line 111 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp26_ = best_recursive_matches;
#line 111 "../plugins/fuzzy-search/fuzzy-finder.vala"
					gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp26_);
#line 112 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp27_ = best_recursive_matches;
#line 112 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp28_ = recursive_matches;
#line 112 "../plugins/fuzzy-search/fuzzy-finder.vala"
					gee_list_insert_all ((GeeList*) _tmp27_, 0, (GeeCollection*) _tmp28_);
#line 113 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp29_ = recursive_result_search;
#line 113 "../plugins/fuzzy-search/fuzzy-finder.vala"
					best_recursive_score = _tmp29_->score;
#line 1672 "fuzzy-finder.c"
				}
#line 115 "../plugins/fuzzy-search/fuzzy-finder.vala"
				recursive_match = TRUE;
#line 1676 "fuzzy-finder.c"
			}
#line 118 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp30_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) matches);
#line 118 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp31_ = _tmp30_;
#line 118 "../plugins/fuzzy-search/fuzzy-finder.vala"
			if (_tmp31_ <= next_match) {
#line 119 "../plugins/fuzzy-search/fuzzy-finder.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) matches, (gpointer) ((gintptr) str_current_index));
#line 1686 "fuzzy-finder.c"
			}
#line 122 "../plugins/fuzzy-search/fuzzy-finder.vala"
			next_match = next_match + 1;
#line 122 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp32_ = next_match;
#line 123 "../plugins/fuzzy-search/fuzzy-finder.vala"
			pattern_current_index = pattern_current_index + 1;
#line 123 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp33_ = pattern_current_index;
#line 76 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_search_result_unref0 (recursive_result_search);
#line 76 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_g_object_unref0 (recursive_matches);
#line 1700 "fuzzy-finder.c"
		} else {
			gboolean _tmp34_ = FALSE;
#line 124 "../plugins/fuzzy-search/fuzzy-finder.vala"
			if (pattern_current_index > 0) {
#line 124 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp34_ = ((guint) pattern_current_index) <= dir_length;
#line 1707 "fuzzy-finder.c"
			} else {
#line 124 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp34_ = FALSE;
#line 1711 "fuzzy-finder.c"
			}
#line 124 "../plugins/fuzzy-search/fuzzy-finder.vala"
			if (_tmp34_) {
#line 125 "../plugins/fuzzy-search/fuzzy-finder.vala"
				break;
#line 1717 "fuzzy-finder.c"
			} else {
				gboolean _tmp35_ = FALSE;
#line 126 "../plugins/fuzzy-search/fuzzy-finder.vala"
				if (lower_case_str_char == ((gunichar) G_DIR_SEPARATOR)) {
#line 126 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp35_ = !allowed_separators;
#line 1724 "fuzzy-finder.c"
				} else {
#line 126 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp35_ = FALSE;
#line 1728 "fuzzy-finder.c"
				}
#line 126 "../plugins/fuzzy-search/fuzzy-finder.vala"
				if (_tmp35_) {
#line 127 "../plugins/fuzzy-search/fuzzy-finder.vala"
					break;
#line 1734 "fuzzy-finder.c"
				}
			}
		}
#line 130 "../plugins/fuzzy-search/fuzzy-finder.vala"
		str_current_index = str_current_index + 1;
#line 130 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_tmp36_ = str_current_index;
#line 1742 "fuzzy-finder.c"
	}
#line 133 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp37_ = strlen (pattern);
#line 133 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp38_ = _tmp37_;
#line 133 "../plugins/fuzzy-search/fuzzy-finder.vala"
	matched = pattern_current_index == _tmp38_;
#line 134 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (matched) {
#line 1752 "fuzzy-finder.c"
		gint penalty = 0;
		gpointer _tmp39_;
		gint _tmp40_ = 0;
		gint unmatched = 0;
		gint _tmp41_;
		gint _tmp42_;
#line 135 "../plugins/fuzzy-search/fuzzy-finder.vala"
		out_score = 100;
#line 138 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_tmp39_ = gee_abstract_list_get ((GeeAbstractList*) matches, 0);
#line 138 "../plugins/fuzzy-search/fuzzy-finder.vala"
		penalty = LEADING_LETTER_PENALTY * ((gint) ((gintptr) _tmp39_));
#line 140 "../plugins/fuzzy-search/fuzzy-finder.vala"
		if (penalty < MAX_LEADING_LETTER_PENALTY) {
#line 141 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp40_ = MAX_LEADING_LETTER_PENALTY;
#line 1769 "fuzzy-finder.c"
		} else {
#line 142 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp40_ = penalty;
#line 1773 "fuzzy-finder.c"
		}
#line 139 "../plugins/fuzzy-search/fuzzy-finder.vala"
		penalty = _tmp40_;
#line 143 "../plugins/fuzzy-search/fuzzy-finder.vala"
		out_score += penalty;
#line 146 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_tmp41_ = strlen (str);
#line 146 "../plugins/fuzzy-search/fuzzy-finder.vala"
		_tmp42_ = _tmp41_;
#line 146 "../plugins/fuzzy-search/fuzzy-finder.vala"
		unmatched = _tmp42_ - next_match;
#line 147 "../plugins/fuzzy-search/fuzzy-finder.vala"
		out_score += UNMATCHED_LETTER_PENALTY * unmatched;
#line 1787 "fuzzy-finder.c"
		{
			gint i = 0;
#line 150 "../plugins/fuzzy-search/fuzzy-finder.vala"
			i = 0;
#line 1792 "fuzzy-finder.c"
			{
				gboolean _tmp43_ = FALSE;
#line 150 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp43_ = TRUE;
#line 150 "../plugins/fuzzy-search/fuzzy-finder.vala"
				while (TRUE) {
#line 1799 "fuzzy-finder.c"
					gint current_index = 0;
					gpointer _tmp46_;
#line 150 "../plugins/fuzzy-search/fuzzy-finder.vala"
					if (!_tmp43_) {
#line 1804 "fuzzy-finder.c"
						gint _tmp44_;
#line 150 "../plugins/fuzzy-search/fuzzy-finder.vala"
						_tmp44_ = i;
#line 150 "../plugins/fuzzy-search/fuzzy-finder.vala"
						i = _tmp44_ + 1;
#line 1810 "fuzzy-finder.c"
					}
#line 150 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp43_ = FALSE;
#line 150 "../plugins/fuzzy-search/fuzzy-finder.vala"
					if (!(i < next_match)) {
#line 150 "../plugins/fuzzy-search/fuzzy-finder.vala"
						break;
#line 1818 "fuzzy-finder.c"
					}
#line 151 "../plugins/fuzzy-search/fuzzy-finder.vala"
					if (g_cancellable_is_cancelled (cancellable)) {
#line 1822 "fuzzy-finder.c"
						SearchResult* _tmp45_;
#line 152 "../plugins/fuzzy-search/fuzzy-finder.vala"
						_tmp45_ = search_result_new (FALSE, out_score);
#line 152 "../plugins/fuzzy-search/fuzzy-finder.vala"
						result = _tmp45_;
#line 152 "../plugins/fuzzy-search/fuzzy-finder.vala"
						_g_object_unref0 (best_recursive_matches);
#line 152 "../plugins/fuzzy-search/fuzzy-finder.vala"
						return result;
#line 1832 "fuzzy-finder.c"
					}
#line 155 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp46_ = gee_abstract_list_get ((GeeAbstractList*) matches, i);
#line 155 "../plugins/fuzzy-search/fuzzy-finder.vala"
					current_index = (gint) ((gintptr) _tmp46_);
#line 157 "../plugins/fuzzy-search/fuzzy-finder.vala"
					if (i > 0) {
#line 1840 "fuzzy-finder.c"
						gint previous_index = 0;
						gpointer _tmp47_;
#line 158 "../plugins/fuzzy-search/fuzzy-finder.vala"
						_tmp47_ = gee_abstract_list_get ((GeeAbstractList*) matches, i - 1);
#line 158 "../plugins/fuzzy-search/fuzzy-finder.vala"
						previous_index = (gint) ((gintptr) _tmp47_);
#line 160 "../plugins/fuzzy-search/fuzzy-finder.vala"
						if (current_index == (previous_index + 1)) {
#line 161 "../plugins/fuzzy-search/fuzzy-finder.vala"
							out_score += SEQUENTIAL_BONUS;
#line 1851 "fuzzy-finder.c"
						}
					}
#line 166 "../plugins/fuzzy-search/fuzzy-finder.vala"
					if (current_index > 0) {
#line 1856 "fuzzy-finder.c"
						gchar neighbor = '\0';
						gchar curr = '\0';
						gboolean _tmp48_ = FALSE;
						gboolean _tmp49_ = FALSE;
						gboolean is_neighbour_separator = FALSE;
#line 168 "../plugins/fuzzy-search/fuzzy-finder.vala"
						neighbor = string_get (str, (glong) (current_index - 1));
#line 169 "../plugins/fuzzy-search/fuzzy-finder.vala"
						curr = string_get (str, (glong) current_index);
#line 170 "../plugins/fuzzy-search/fuzzy-finder.vala"
						if (neighbor != g_ascii_toupper (neighbor)) {
#line 170 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp48_ = curr != g_ascii_tolower (curr);
#line 1870 "fuzzy-finder.c"
						} else {
#line 170 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp48_ = FALSE;
#line 1874 "fuzzy-finder.c"
						}
#line 170 "../plugins/fuzzy-search/fuzzy-finder.vala"
						if (_tmp48_) {
#line 171 "../plugins/fuzzy-search/fuzzy-finder.vala"
							out_score += CAMEL_BONUS;
#line 1880 "fuzzy-finder.c"
						}
#line 174 "../plugins/fuzzy-search/fuzzy-finder.vala"
						if (neighbor == '_') {
#line 174 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp49_ = TRUE;
#line 1886 "fuzzy-finder.c"
						} else {
#line 174 "../plugins/fuzzy-search/fuzzy-finder.vala"
							_tmp49_ = neighbor == ' ';
#line 1890 "fuzzy-finder.c"
						}
#line 174 "../plugins/fuzzy-search/fuzzy-finder.vala"
						is_neighbour_separator = _tmp49_;
#line 175 "../plugins/fuzzy-search/fuzzy-finder.vala"
						if (is_neighbour_separator) {
#line 176 "../plugins/fuzzy-search/fuzzy-finder.vala"
							out_score += SEPARATOR_BONUS;
#line 1898 "fuzzy-finder.c"
						}
					} else {
#line 180 "../plugins/fuzzy-search/fuzzy-finder.vala"
						out_score += FIRST_LETTER_BONUS;
#line 1903 "fuzzy-finder.c"
					}
				}
			}
		}
#line 185 "../plugins/fuzzy-search/fuzzy-finder.vala"
		if (out_score <= 0) {
#line 1910 "fuzzy-finder.c"
			SearchResult* _tmp50_;
#line 186 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_tmp50_ = search_result_new (FALSE, out_score);
#line 186 "../plugins/fuzzy-search/fuzzy-finder.vala"
			result = _tmp50_;
#line 186 "../plugins/fuzzy-search/fuzzy-finder.vala"
			_g_object_unref0 (best_recursive_matches);
#line 186 "../plugins/fuzzy-search/fuzzy-finder.vala"
			return result;
#line 1920 "fuzzy-finder.c"
		} else {
			gboolean _tmp51_ = FALSE;
#line 187 "../plugins/fuzzy-search/fuzzy-finder.vala"
			if (recursive_match) {
#line 1925 "fuzzy-finder.c"
				gboolean _tmp52_ = FALSE;
#line 187 "../plugins/fuzzy-search/fuzzy-finder.vala"
				if (!matched) {
#line 187 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp52_ = TRUE;
#line 1931 "fuzzy-finder.c"
				} else {
#line 187 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp52_ = best_recursive_score > out_score;
#line 1935 "fuzzy-finder.c"
				}
#line 187 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp51_ = _tmp52_;
#line 1939 "fuzzy-finder.c"
			} else {
#line 187 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp51_ = FALSE;
#line 1943 "fuzzy-finder.c"
			}
#line 187 "../plugins/fuzzy-search/fuzzy-finder.vala"
			if (_tmp51_) {
#line 1947 "fuzzy-finder.c"
				GeeArrayList* _tmp53_;
				SearchResult* _tmp54_;
#line 189 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp53_ = best_recursive_matches;
#line 189 "../plugins/fuzzy-search/fuzzy-finder.vala"
				gee_list_insert_all ((GeeList*) matches, 0, (GeeCollection*) _tmp53_);
#line 190 "../plugins/fuzzy-search/fuzzy-finder.vala"
				out_score = best_recursive_score;
#line 191 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_tmp54_ = search_result_new (TRUE, out_score);
#line 191 "../plugins/fuzzy-search/fuzzy-finder.vala"
				result = _tmp54_;
#line 191 "../plugins/fuzzy-search/fuzzy-finder.vala"
				_g_object_unref0 (best_recursive_matches);
#line 191 "../plugins/fuzzy-search/fuzzy-finder.vala"
				return result;
#line 1964 "fuzzy-finder.c"
			} else {
#line 192 "../plugins/fuzzy-search/fuzzy-finder.vala"
				if (matched) {
#line 1968 "fuzzy-finder.c"
					SearchResult* _tmp55_;
#line 194 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp55_ = search_result_new (TRUE, out_score);
#line 194 "../plugins/fuzzy-search/fuzzy-finder.vala"
					result = _tmp55_;
#line 194 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_g_object_unref0 (best_recursive_matches);
#line 194 "../plugins/fuzzy-search/fuzzy-finder.vala"
					return result;
#line 1978 "fuzzy-finder.c"
				} else {
					SearchResult* _tmp56_;
#line 196 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_tmp56_ = search_result_new (FALSE, out_score);
#line 196 "../plugins/fuzzy-search/fuzzy-finder.vala"
					result = _tmp56_;
#line 196 "../plugins/fuzzy-search/fuzzy-finder.vala"
					_g_object_unref0 (best_recursive_matches);
#line 196 "../plugins/fuzzy-search/fuzzy-finder.vala"
					return result;
#line 1989 "fuzzy-finder.c"
				}
			}
		}
	}
#line 199 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_tmp57_ = search_result_new (FALSE, out_score);
#line 199 "../plugins/fuzzy-search/fuzzy-finder.vala"
	result = _tmp57_;
#line 199 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_object_unref0 (best_recursive_matches);
#line 199 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return result;
#line 2002 "fuzzy-finder.c"
}

static void
scratch_services_fuzzy_finder_value_recursive_finder_init (GValue* value)
{
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	value->data[0].v_pointer = NULL;
#line 2010 "fuzzy-finder.c"
}

static void
scratch_services_fuzzy_finder_value_recursive_finder_free_value (GValue* value)
{
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (value->data[0].v_pointer) {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		scratch_services_fuzzy_finder_recursive_finder_unref (value->data[0].v_pointer);
#line 2020 "fuzzy-finder.c"
	}
}

static void
scratch_services_fuzzy_finder_value_recursive_finder_copy_value (const GValue* src_value,
                                                                 GValue* dest_value)
{
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (src_value->data[0].v_pointer) {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		dest_value->data[0].v_pointer = scratch_services_fuzzy_finder_recursive_finder_ref (src_value->data[0].v_pointer);
#line 2032 "fuzzy-finder.c"
	} else {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2036 "fuzzy-finder.c"
	}
}

static gpointer
scratch_services_fuzzy_finder_value_recursive_finder_peek_pointer (const GValue* value)
{
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return value->data[0].v_pointer;
#line 2045 "fuzzy-finder.c"
}

static gchar*
scratch_services_fuzzy_finder_value_recursive_finder_collect_value (GValue* value,
                                                                    guint n_collect_values,
                                                                    GTypeCValue* collect_values,
                                                                    guint collect_flags)
{
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (collect_values[0].v_pointer) {
#line 2056 "fuzzy-finder.c"
		ScratchServicesFuzzyFinderRecursiveFinder * object;
		object = collect_values[0].v_pointer;
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		if (object->parent_instance.g_class == NULL) {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2063 "fuzzy-finder.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2067 "fuzzy-finder.c"
		}
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		value->data[0].v_pointer = scratch_services_fuzzy_finder_recursive_finder_ref (object);
#line 2071 "fuzzy-finder.c"
	} else {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		value->data[0].v_pointer = NULL;
#line 2075 "fuzzy-finder.c"
	}
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return NULL;
#line 2079 "fuzzy-finder.c"
}

static gchar*
scratch_services_fuzzy_finder_value_recursive_finder_lcopy_value (const GValue* value,
                                                                  guint n_collect_values,
                                                                  GTypeCValue* collect_values,
                                                                  guint collect_flags)
{
	ScratchServicesFuzzyFinderRecursiveFinder ** object_p;
	object_p = collect_values[0].v_pointer;
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (!object_p) {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2094 "fuzzy-finder.c"
	}
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (!value->data[0].v_pointer) {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		*object_p = NULL;
#line 2100 "fuzzy-finder.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		*object_p = value->data[0].v_pointer;
#line 2104 "fuzzy-finder.c"
	} else {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		*object_p = scratch_services_fuzzy_finder_recursive_finder_ref (value->data[0].v_pointer);
#line 2108 "fuzzy-finder.c"
	}
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return NULL;
#line 2112 "fuzzy-finder.c"
}

static GParamSpec*
scratch_services_fuzzy_finder_param_spec_recursive_finder (const gchar* name,
                                                           const gchar* nick,
                                                           const gchar* blurb,
                                                           GType object_type,
                                                           GParamFlags flags)
{
	ScratchServicesFuzzyFinderParamSpecRecursiveFinder* spec;
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (g_type_is_a (object_type, SCRATCH_SERVICES_FUZZY_FINDER_TYPE_RECURSIVE_FINDER), NULL);
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return G_PARAM_SPEC (spec);
#line 2131 "fuzzy-finder.c"
}

static gpointer
scratch_services_fuzzy_finder_value_get_recursive_finder (const GValue* value)
{
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SCRATCH_SERVICES_FUZZY_FINDER_TYPE_RECURSIVE_FINDER), NULL);
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return value->data[0].v_pointer;
#line 2141 "fuzzy-finder.c"
}

static void
scratch_services_fuzzy_finder_value_set_recursive_finder (GValue* value,
                                                          gpointer v_object)
{
	ScratchServicesFuzzyFinderRecursiveFinder * old;
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SCRATCH_SERVICES_FUZZY_FINDER_TYPE_RECURSIVE_FINDER));
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	old = value->data[0].v_pointer;
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (v_object) {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SCRATCH_SERVICES_FUZZY_FINDER_TYPE_RECURSIVE_FINDER));
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		value->data[0].v_pointer = v_object;
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		scratch_services_fuzzy_finder_recursive_finder_ref (value->data[0].v_pointer);
#line 2163 "fuzzy-finder.c"
	} else {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		value->data[0].v_pointer = NULL;
#line 2167 "fuzzy-finder.c"
	}
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (old) {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		scratch_services_fuzzy_finder_recursive_finder_unref (old);
#line 2173 "fuzzy-finder.c"
	}
}

static void
scratch_services_fuzzy_finder_value_take_recursive_finder (GValue* value,
                                                           gpointer v_object)
{
	ScratchServicesFuzzyFinderRecursiveFinder * old;
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SCRATCH_SERVICES_FUZZY_FINDER_TYPE_RECURSIVE_FINDER));
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	old = value->data[0].v_pointer;
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (v_object) {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SCRATCH_SERVICES_FUZZY_FINDER_TYPE_RECURSIVE_FINDER));
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		value->data[0].v_pointer = v_object;
#line 2194 "fuzzy-finder.c"
	} else {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		value->data[0].v_pointer = NULL;
#line 2198 "fuzzy-finder.c"
	}
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (old) {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		scratch_services_fuzzy_finder_recursive_finder_unref (old);
#line 2204 "fuzzy-finder.c"
	}
}

static void
scratch_services_fuzzy_finder_recursive_finder_class_init (ScratchServicesFuzzyFinderRecursiveFinderClass * klass,
                                                           gpointer klass_data)
{
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	scratch_services_fuzzy_finder_recursive_finder_parent_class = g_type_class_peek_parent (klass);
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	((ScratchServicesFuzzyFinderRecursiveFinderClass *) klass)->finalize = scratch_services_fuzzy_finder_recursive_finder_finalize;
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_type_class_adjust_private_offset (klass, &ScratchServicesFuzzyFinderRecursiveFinder_private_offset);
#line 2218 "fuzzy-finder.c"
}

static void
scratch_services_fuzzy_finder_recursive_finder_instance_init (ScratchServicesFuzzyFinderRecursiveFinder * self,
                                                              gpointer klass)
{
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self->priv = scratch_services_fuzzy_finder_recursive_finder_get_instance_private (self);
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self->ref_count = 1;
#line 2229 "fuzzy-finder.c"
}

static void
scratch_services_fuzzy_finder_recursive_finder_finalize (ScratchServicesFuzzyFinderRecursiveFinder * obj)
{
	ScratchServicesFuzzyFinderRecursiveFinder * self;
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_SERVICES_FUZZY_FINDER_TYPE_RECURSIVE_FINDER, ScratchServicesFuzzyFinderRecursiveFinder);
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_signal_handlers_destroy (self);
#line 2240 "fuzzy-finder.c"
}

GType
scratch_services_fuzzy_finder_recursive_finder_get_type (void)
{
	return scratch_services_fuzzy_finder_recursive_finder_type_id;
}

GType
scratch_services_fuzzy_finder_recursive_finder_register_type (GTypeModule * module)
{
	static const GTypeValueTable g_define_type_value_table = { scratch_services_fuzzy_finder_value_recursive_finder_init, scratch_services_fuzzy_finder_value_recursive_finder_free_value, scratch_services_fuzzy_finder_value_recursive_finder_copy_value, scratch_services_fuzzy_finder_value_recursive_finder_peek_pointer, "p", scratch_services_fuzzy_finder_value_recursive_finder_collect_value, "p", scratch_services_fuzzy_finder_value_recursive_finder_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ScratchServicesFuzzyFinderRecursiveFinderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scratch_services_fuzzy_finder_recursive_finder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScratchServicesFuzzyFinderRecursiveFinder), 0, (GInstanceInitFunc) scratch_services_fuzzy_finder_recursive_finder_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	scratch_services_fuzzy_finder_recursive_finder_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ScratchServicesFuzzyFinderRecursiveFinder", &g_define_type_info, &g_define_type_fundamental_info, 0);
	ScratchServicesFuzzyFinderRecursiveFinder_private_offset = sizeof (ScratchServicesFuzzyFinderRecursiveFinderPrivate);
	return scratch_services_fuzzy_finder_recursive_finder_type_id;
}

static gpointer
scratch_services_fuzzy_finder_recursive_finder_ref (gpointer instance)
{
	ScratchServicesFuzzyFinderRecursiveFinder * self;
	self = instance;
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_atomic_int_inc (&self->ref_count);
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return instance;
#line 2269 "fuzzy-finder.c"
}

static void
scratch_services_fuzzy_finder_recursive_finder_unref (gpointer instance)
{
	ScratchServicesFuzzyFinderRecursiveFinder * self;
	self = instance;
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		SCRATCH_SERVICES_FUZZY_FINDER_RECURSIVE_FINDER_GET_CLASS (self)->finalize (self);
#line 19 "../plugins/fuzzy-search/fuzzy-finder.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2283 "fuzzy-finder.c"
	}
}

static void
scratch_services_value_fuzzy_finder_init (GValue* value)
{
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	value->data[0].v_pointer = NULL;
#line 2292 "fuzzy-finder.c"
}

static void
scratch_services_value_fuzzy_finder_free_value (GValue* value)
{
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (value->data[0].v_pointer) {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		scratch_services_fuzzy_finder_unref (value->data[0].v_pointer);
#line 2302 "fuzzy-finder.c"
	}
}

static void
scratch_services_value_fuzzy_finder_copy_value (const GValue* src_value,
                                                GValue* dest_value)
{
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (src_value->data[0].v_pointer) {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		dest_value->data[0].v_pointer = scratch_services_fuzzy_finder_ref (src_value->data[0].v_pointer);
#line 2314 "fuzzy-finder.c"
	} else {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2318 "fuzzy-finder.c"
	}
}

static gpointer
scratch_services_value_fuzzy_finder_peek_pointer (const GValue* value)
{
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return value->data[0].v_pointer;
#line 2327 "fuzzy-finder.c"
}

static gchar*
scratch_services_value_fuzzy_finder_collect_value (GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (collect_values[0].v_pointer) {
#line 2338 "fuzzy-finder.c"
		ScratchServicesFuzzyFinder * object;
		object = collect_values[0].v_pointer;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		if (object->parent_instance.g_class == NULL) {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2345 "fuzzy-finder.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2349 "fuzzy-finder.c"
		}
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		value->data[0].v_pointer = scratch_services_fuzzy_finder_ref (object);
#line 2353 "fuzzy-finder.c"
	} else {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		value->data[0].v_pointer = NULL;
#line 2357 "fuzzy-finder.c"
	}
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return NULL;
#line 2361 "fuzzy-finder.c"
}

static gchar*
scratch_services_value_fuzzy_finder_lcopy_value (const GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
	ScratchServicesFuzzyFinder ** object_p;
	object_p = collect_values[0].v_pointer;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (!object_p) {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2376 "fuzzy-finder.c"
	}
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (!value->data[0].v_pointer) {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		*object_p = NULL;
#line 2382 "fuzzy-finder.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		*object_p = value->data[0].v_pointer;
#line 2386 "fuzzy-finder.c"
	} else {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		*object_p = scratch_services_fuzzy_finder_ref (value->data[0].v_pointer);
#line 2390 "fuzzy-finder.c"
	}
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return NULL;
#line 2394 "fuzzy-finder.c"
}

GParamSpec*
scratch_services_param_spec_fuzzy_finder (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags)
{
	ScratchServicesParamSpecFuzzyFinder* spec;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (g_type_is_a (object_type, SCRATCH_SERVICES_TYPE_FUZZY_FINDER), NULL);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return G_PARAM_SPEC (spec);
#line 2413 "fuzzy-finder.c"
}

gpointer
scratch_services_value_get_fuzzy_finder (const GValue* value)
{
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SCRATCH_SERVICES_TYPE_FUZZY_FINDER), NULL);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return value->data[0].v_pointer;
#line 2423 "fuzzy-finder.c"
}

void
scratch_services_value_set_fuzzy_finder (GValue* value,
                                         gpointer v_object)
{
	ScratchServicesFuzzyFinder * old;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SCRATCH_SERVICES_TYPE_FUZZY_FINDER));
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	old = value->data[0].v_pointer;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (v_object) {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SCRATCH_SERVICES_TYPE_FUZZY_FINDER));
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		value->data[0].v_pointer = v_object;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		scratch_services_fuzzy_finder_ref (value->data[0].v_pointer);
#line 2445 "fuzzy-finder.c"
	} else {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		value->data[0].v_pointer = NULL;
#line 2449 "fuzzy-finder.c"
	}
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (old) {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		scratch_services_fuzzy_finder_unref (old);
#line 2455 "fuzzy-finder.c"
	}
}

void
scratch_services_value_take_fuzzy_finder (GValue* value,
                                          gpointer v_object)
{
	ScratchServicesFuzzyFinder * old;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SCRATCH_SERVICES_TYPE_FUZZY_FINDER));
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	old = value->data[0].v_pointer;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (v_object) {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SCRATCH_SERVICES_TYPE_FUZZY_FINDER));
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		value->data[0].v_pointer = v_object;
#line 2476 "fuzzy-finder.c"
	} else {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		value->data[0].v_pointer = NULL;
#line 2480 "fuzzy-finder.c"
	}
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (old) {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		scratch_services_fuzzy_finder_unref (old);
#line 2486 "fuzzy-finder.c"
	}
}

static void
scratch_services_fuzzy_finder_class_init (ScratchServicesFuzzyFinderClass * klass,
                                          gpointer klass_data)
{
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	scratch_services_fuzzy_finder_parent_class = g_type_class_peek_parent (klass);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	((ScratchServicesFuzzyFinderClass *) klass)->finalize = scratch_services_fuzzy_finder_finalize;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_type_class_adjust_private_offset (klass, &ScratchServicesFuzzyFinder_private_offset);
#line 2500 "fuzzy-finder.c"
}

static void
scratch_services_fuzzy_finder_instance_init (ScratchServicesFuzzyFinder * self,
                                             gpointer klass)
{
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self->priv = scratch_services_fuzzy_finder_get_instance_private (self);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self->ref_count = 1;
#line 2511 "fuzzy-finder.c"
}

static void
scratch_services_fuzzy_finder_finalize (ScratchServicesFuzzyFinder * obj)
{
	ScratchServicesFuzzyFinder * self;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_SERVICES_TYPE_FUZZY_FINDER, ScratchServicesFuzzyFinder);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_signal_handlers_destroy (self);
#line 205 "../plugins/fuzzy-search/fuzzy-finder.vala"
	_g_object_unref0 (self->priv->project_paths);
#line 2524 "fuzzy-finder.c"
}

GType
scratch_services_fuzzy_finder_get_type (void)
{
	return scratch_services_fuzzy_finder_type_id;
}

GType
scratch_services_fuzzy_finder_register_type (GTypeModule * module)
{
	static const GTypeValueTable g_define_type_value_table = { scratch_services_value_fuzzy_finder_init, scratch_services_value_fuzzy_finder_free_value, scratch_services_value_fuzzy_finder_copy_value, scratch_services_value_fuzzy_finder_peek_pointer, "p", scratch_services_value_fuzzy_finder_collect_value, "p", scratch_services_value_fuzzy_finder_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ScratchServicesFuzzyFinderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scratch_services_fuzzy_finder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScratchServicesFuzzyFinder), 0, (GInstanceInitFunc) scratch_services_fuzzy_finder_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	scratch_services_fuzzy_finder_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ScratchServicesFuzzyFinder", &g_define_type_info, &g_define_type_fundamental_info, 0);
	ScratchServicesFuzzyFinder_private_offset = sizeof (ScratchServicesFuzzyFinderPrivate);
	return scratch_services_fuzzy_finder_type_id;
}

gpointer
scratch_services_fuzzy_finder_ref (gpointer instance)
{
	ScratchServicesFuzzyFinder * self;
	self = instance;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	g_atomic_int_inc (&self->ref_count);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	return instance;
#line 2553 "fuzzy-finder.c"
}

void
scratch_services_fuzzy_finder_unref (gpointer instance)
{
	ScratchServicesFuzzyFinder * self;
	self = instance;
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		SCRATCH_SERVICES_FUZZY_FINDER_GET_CLASS (self)->finalize (self);
#line 18 "../plugins/fuzzy-search/fuzzy-finder.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2567 "fuzzy-finder.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

