/* fuzzy-search.c generated by valac 0.56.15, the Vala compiler
 * generated from fuzzy-search.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2023 elementary, Inc. <https://elementary.io>
 *
 * Authored by: Marvin Ahlgrimm
 */

#include "fuzzy-search.h"
#include <glib-object.h>
#include "codecore.h"
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <libpeas/peas.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

#define SCRATCH_PLUGINS_FUZZY_SEARCH_ACCEL_KEY GDK_KEY_F
#define SCRATCH_PLUGINS_FUZZY_SEARCH_ACCEL_MODTYPE GDK_MOD1_MASK
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SCRATCH_PLUGINS_FUZZY_SEARCH_0_PROPERTY,
	SCRATCH_PLUGINS_FUZZY_SEARCH_OBJECT_PROPERTY,
	SCRATCH_PLUGINS_FUZZY_SEARCH_NUM_PROPERTIES
};
static GParamSpec* scratch_plugins_fuzzy_search_properties[SCRATCH_PLUGINS_FUZZY_SEARCH_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;

struct _ScratchPluginsFuzzySearchPrivate {
	GObject* _object;
	ScratchServicesFuzzySearchIndexer* indexer;
	ScratchMainWindow* window;
	ScratchServicesInterface* plugins;
	GtkEventControllerKey* key_controller;
	GtkMenuItem* fuzzy_menuitem;
	GCancellable* cancellable;
};

struct _Block1Data {
	int _ref_count_;
	ScratchPluginsFuzzySearch* self;
	ScratchFuzzySearchPopover* popover;
};

static gint ScratchPluginsFuzzySearch_private_offset;
static gpointer scratch_plugins_fuzzy_search_parent_class = NULL;
static PeasActivatableInterface * scratch_plugins_fuzzy_search_peas_activatable_parent_iface = NULL;
static GType scratch_plugins_fuzzy_search_type_id = 0;

static void scratch_plugins_fuzzy_search_real_update_state (PeasActivatable* base);
static void scratch_plugins_fuzzy_search_real_activate (PeasActivatable* base);
static void __lambda17_ (ScratchPluginsFuzzySearch* self,
                  ScratchMainWindow* w);
static void __lambda18_ (ScratchPluginsFuzzySearch* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda18__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static gboolean scratch_plugins_fuzzy_search_on_window_key_press_event (ScratchPluginsFuzzySearch* self,
                                                                 guint keyval,
                                                                 guint keycode,
                                                                 GdkModifierType state);
static gboolean _scratch_plugins_fuzzy_search_on_window_key_press_event_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                                       guint keyval,
                                                                                                       guint keycode,
                                                                                                       GdkModifierType state,
                                                                                                       gpointer self);
static void scratch_plugins_fuzzy_search_fuzzy_find (ScratchPluginsFuzzySearch* self);
static void _scratch_plugins_fuzzy_search_fuzzy_find_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                      gpointer self);
static void ___lambda17__scratch_services_interface_hook_window (ScratchServicesInterface* _sender,
                                                          ScratchMainWindow* window,
                                                          gpointer self);
static void __lambda29_ (ScratchPluginsFuzzySearch* self,
                  GFile* src,
                  GFile* dest,
                  GFileMonitorEvent event);
static void ___lambda29__scratch_services_interface_hook_folder_item_change (ScratchServicesInterface* _sender,
                                                                      GFile* file,
                                                                      GFile* other_file,
                                                                      GFileMonitorEvent event_type,
                                                                      gpointer self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda27_ (Block1Data* _data1_,
                  const gchar* filepath);
static void ___lambda27__scratch_fuzzy_search_popover_open_file (ScratchFuzzySearchPopover* _sender,
                                                          const gchar* filepath,
                                                          gpointer self);
static void __lambda28_ (Block1Data* _data1_);
static void ___lambda28__scratch_fuzzy_search_popover_close_search (ScratchFuzzySearchPopover* _sender,
                                                             gpointer self);
static void scratch_plugins_fuzzy_search_real_deactivate (PeasActivatable* base);
static void scratch_plugins_fuzzy_search_finalize (GObject * obj);
static void _vala_scratch_plugins_fuzzy_search_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_scratch_plugins_fuzzy_search_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
GType scratch_services_fuzzy_finder_register_type (GTypeModule * module);
GType scratch_services_fuzzy_finder_recursive_finder_register_type (GTypeModule * module);
GType scratch_services_fuzzy_search_indexer_register_type (GTypeModule * module);
GType scratch_services_search_project_register_type (GTypeModule * module);
GType scratch_fuzzy_search_popover_register_type (GTypeModule * module);
GType file_item_register_type (GTypeModule * module);
GType indexer_message_register_type (GTypeModule * module);
GType initial_index_request_register_type (GTypeModule * module);
GType project_update_register_type (GTypeModule * module);
GType search_result_register_type (GTypeModule * module);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
scratch_plugins_fuzzy_search_get_instance_private (ScratchPluginsFuzzySearch* self)
{
	return G_STRUCT_MEMBER_P (self, ScratchPluginsFuzzySearch_private_offset);
}

static void
scratch_plugins_fuzzy_search_real_update_state (PeasActivatable* base)
{
	ScratchPluginsFuzzySearch * self;
#line 21 "../plugins/fuzzy-search/fuzzy-search.vala"
	self = (ScratchPluginsFuzzySearch*) base;
#line 149 "fuzzy-search.c"
}

static void
__lambda18_ (ScratchPluginsFuzzySearch* self,
             GObject* obj,
             GAsyncResult* res)
{
	ScratchServicesFuzzySearchIndexer* _tmp0_;
#line 36 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_return_if_fail (res != NULL);
#line 37 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp0_ = self->priv->indexer;
#line 37 "../plugins/fuzzy-search/fuzzy-search.vala"
	scratch_services_fuzzy_search_indexer_start_finish (_tmp0_, res);
#line 164 "fuzzy-search.c"
}

static void
___lambda18__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 36 "../plugins/fuzzy-search/fuzzy-search.vala"
	__lambda18_ ((ScratchPluginsFuzzySearch*) self, source_object, res);
#line 36 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_object_unref (self);
#line 176 "fuzzy-search.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 40 "../plugins/fuzzy-search/fuzzy-search.vala"
	return self ? g_object_ref (self) : NULL;
#line 184 "fuzzy-search.c"
}

static gboolean
_scratch_plugins_fuzzy_search_on_window_key_press_event_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                              guint keyval,
                                                                                              guint keycode,
                                                                                              GdkModifierType state,
                                                                                              gpointer self)
{
	gboolean result;
	result = scratch_plugins_fuzzy_search_on_window_key_press_event ((ScratchPluginsFuzzySearch*) self, keyval, keycode, state);
#line 45 "../plugins/fuzzy-search/fuzzy-search.vala"
	return result;
#line 198 "fuzzy-search.c"
}

static void
_scratch_plugins_fuzzy_search_fuzzy_find_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                 gpointer self)
{
#line 53 "../plugins/fuzzy-search/fuzzy-search.vala"
	scratch_plugins_fuzzy_search_fuzzy_find ((ScratchPluginsFuzzySearch*) self);
#line 207 "fuzzy-search.c"
}

static void
__lambda17_ (ScratchPluginsFuzzySearch* self,
             ScratchMainWindow* w)
{
	ScratchMainWindow* _tmp0_;
	GCancellable* _tmp1_;
	GCancellable* _tmp2_;
	ScratchServicesFuzzySearchIndexer* _tmp3_;
	ScratchServicesFuzzySearchIndexer* _tmp4_;
	ScratchMainWindow* _tmp5_;
	ScratchMainWindow* _tmp6_;
	GtkEventControllerKey* _tmp7_ = NULL;
	GtkEventControllerKey* _tmp8_;
	GtkMenuItem* _tmp9_;
	GtkWidget* child = NULL;
	GtkMenuItem* _tmp10_;
	GtkWidget* _tmp11_;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkMenuItem* _tmp15_;
	GtkMenuItem* _tmp16_;
	ScratchMainWindow* _tmp17_;
	CodeSidebar* _tmp18_;
	GtkMenu* _tmp19_;
	GtkMenu* _tmp20_;
	GtkMenuItem* _tmp21_;
#line 28 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_return_if_fail (w != NULL);
#line 29 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp0_ = self->priv->window;
#line 29 "../plugins/fuzzy-search/fuzzy-search.vala"
	if (_tmp0_ != NULL) {
#line 30 "../plugins/fuzzy-search/fuzzy-search.vala"
		return;
#line 244 "fuzzy-search.c"
	}
#line 33 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp1_ = g_cancellable_new ();
#line 33 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 33 "../plugins/fuzzy-search/fuzzy-search.vala"
	self->priv->cancellable = _tmp1_;
#line 34 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp2_ = self->priv->cancellable;
#line 34 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp3_ = scratch_services_fuzzy_search_indexer_new (_tmp2_);
#line 34 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (self->priv->indexer);
#line 34 "../plugins/fuzzy-search/fuzzy-search.vala"
	self->priv->indexer = _tmp3_;
#line 36 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp4_ = self->priv->indexer;
#line 36 "../plugins/fuzzy-search/fuzzy-search.vala"
	scratch_services_fuzzy_search_indexer_start_async (_tmp4_, ___lambda18__gasync_ready_callback, g_object_ref (self));
#line 40 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp5_ = _g_object_ref0 (w);
#line 40 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (self->priv->window);
#line 40 "../plugins/fuzzy-search/fuzzy-search.vala"
	self->priv->window = _tmp5_;
#line 41 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp6_ = self->priv->window;
#line 41 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp7_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) _tmp6_);
#line 41 "../plugins/fuzzy-search/fuzzy-search.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp7_, GTK_PHASE_BUBBLE);
#line 41 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 41 "../plugins/fuzzy-search/fuzzy-search.vala"
	self->priv->key_controller = _tmp7_;
#line 45 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp8_ = self->priv->key_controller;
#line 45 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_signal_connect_object (_tmp8_, "key-pressed", (GCallback) _scratch_plugins_fuzzy_search_on_window_key_press_event_gtk_event_controller_key_key_pressed, self, 0);
#line 47 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Find Project Files"));
#line 47 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_object_ref_sink (_tmp9_);
#line 47 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (self->priv->fuzzy_menuitem);
#line 47 "../plugins/fuzzy-search/fuzzy-search.vala"
	self->priv->fuzzy_menuitem = _tmp9_;
#line 48 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp10_ = self->priv->fuzzy_menuitem;
#line 48 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp11_ = gtk_bin_get_child (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_bin_get_type (), GtkBin));
#line 48 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 48 "../plugins/fuzzy-search/fuzzy-search.vala"
	child = _tmp12_;
#line 49 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp13_ = child;
#line 49 "../plugins/fuzzy-search/fuzzy-search.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, gtk_accel_label_get_type ())) {
#line 304 "fuzzy-search.c"
		GtkWidget* _tmp14_;
#line 50 "../plugins/fuzzy-search/fuzzy-search.vala"
		_tmp14_ = child;
#line 50 "../plugins/fuzzy-search/fuzzy-search.vala"
		gtk_accel_label_set_accel (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_accel_label_get_type (), GtkAccelLabel), SCRATCH_PLUGINS_FUZZY_SEARCH_ACCEL_KEY, SCRATCH_PLUGINS_FUZZY_SEARCH_ACCEL_MODTYPE);
#line 310 "fuzzy-search.c"
	}
#line 53 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp15_ = self->priv->fuzzy_menuitem;
#line 53 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_signal_connect_object (_tmp15_, "activate", (GCallback) _scratch_plugins_fuzzy_search_fuzzy_find_gtk_menu_item_activate, self, 0);
#line 54 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp16_ = self->priv->fuzzy_menuitem;
#line 54 "../plugins/fuzzy-search/fuzzy-search.vala"
	gtk_widget_show ((GtkWidget*) _tmp16_);
#line 55 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp17_ = self->priv->window;
#line 55 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp18_ = _tmp17_->sidebar;
#line 55 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp19_ = code_sidebar_get_project_menu (_tmp18_);
#line 55 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp20_ = _tmp19_;
#line 55 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp21_ = self->priv->fuzzy_menuitem;
#line 55 "../plugins/fuzzy-search/fuzzy-search.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp20_, _tmp21_);
#line 28 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (child);
#line 334 "fuzzy-search.c"
}

static void
___lambda17__scratch_services_interface_hook_window (ScratchServicesInterface* _sender,
                                                     ScratchMainWindow* window,
                                                     gpointer self)
{
#line 28 "../plugins/fuzzy-search/fuzzy-search.vala"
	__lambda17_ ((ScratchPluginsFuzzySearch*) self, window);
#line 344 "fuzzy-search.c"
}

static void
__lambda29_ (ScratchPluginsFuzzySearch* self,
             GFile* src,
             GFile* dest,
             GFileMonitorEvent event)
{
	ScratchServicesFuzzySearchIndexer* _tmp0_;
	ScratchServicesFuzzySearchIndexer* _tmp1_;
#line 58 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_return_if_fail (src != NULL);
#line 59 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp0_ = self->priv->indexer;
#line 59 "../plugins/fuzzy-search/fuzzy-search.vala"
	if (_tmp0_ == NULL) {
#line 60 "../plugins/fuzzy-search/fuzzy-search.vala"
		return;
#line 363 "fuzzy-search.c"
	}
#line 63 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp1_ = self->priv->indexer;
#line 63 "../plugins/fuzzy-search/fuzzy-search.vala"
	scratch_services_fuzzy_search_indexer_handle_folder_item_change (_tmp1_, src, dest, event);
#line 369 "fuzzy-search.c"
}

static void
___lambda29__scratch_services_interface_hook_folder_item_change (ScratchServicesInterface* _sender,
                                                                 GFile* file,
                                                                 GFile* other_file,
                                                                 GFileMonitorEvent event_type,
                                                                 gpointer self)
{
#line 58 "../plugins/fuzzy-search/fuzzy-search.vala"
	__lambda29_ ((ScratchPluginsFuzzySearch*) self, file, other_file, event_type);
#line 381 "fuzzy-search.c"
}

static void
scratch_plugins_fuzzy_search_real_activate (PeasActivatable* base)
{
	ScratchPluginsFuzzySearch * self;
	GObject* _tmp0_;
	GObject* _tmp1_;
	ScratchServicesInterface* _tmp2_;
	ScratchServicesInterface* _tmp3_;
#line 25 "../plugins/fuzzy-search/fuzzy-search.vala"
	self = (ScratchPluginsFuzzySearch*) base;
#line 26 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_object_get ((PeasActivatable*) self, "object", &_tmp0_, NULL);
#line 26 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp1_ = _tmp0_;
#line 26 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (self->priv->plugins);
#line 26 "../plugins/fuzzy-search/fuzzy-search.vala"
	self->priv->plugins = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, SCRATCH_SERVICES_TYPE_INTERFACE, ScratchServicesInterface);
#line 28 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp2_ = self->priv->plugins;
#line 28 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_signal_connect_object (_tmp2_, "hook-window", (GCallback) ___lambda17__scratch_services_interface_hook_window, self, 0);
#line 58 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp3_ = self->priv->plugins;
#line 58 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_signal_connect_object (_tmp3_, "hook-folder-item-change", (GCallback) ___lambda29__scratch_services_interface_hook_folder_item_change, self, 0);
#line 410 "fuzzy-search.c"
}

static gboolean
scratch_plugins_fuzzy_search_on_window_key_press_event (ScratchPluginsFuzzySearch* self,
                                                        guint keyval,
                                                        guint keycode,
                                                        GdkModifierType state)
{
	gboolean result;
#line 67 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 69 "../plugins/fuzzy-search/fuzzy-search.vala"
	switch (gdk_keyval_to_upper (keyval)) {
#line 69 "../plugins/fuzzy-search/fuzzy-search.vala"
		case SCRATCH_PLUGINS_FUZZY_SEARCH_ACCEL_KEY:
#line 426 "fuzzy-search.c"
		{
#line 71 "../plugins/fuzzy-search/fuzzy-search.vala"
			if (state == SCRATCH_PLUGINS_FUZZY_SEARCH_ACCEL_MODTYPE) {
#line 72 "../plugins/fuzzy-search/fuzzy-search.vala"
				scratch_plugins_fuzzy_search_fuzzy_find (self);
#line 73 "../plugins/fuzzy-search/fuzzy-search.vala"
				result = TRUE;
#line 73 "../plugins/fuzzy-search/fuzzy-search.vala"
				return result;
#line 436 "fuzzy-search.c"
			}
#line 76 "../plugins/fuzzy-search/fuzzy-search.vala"
			break;
#line 440 "fuzzy-search.c"
		}
		default:
		{
#line 78 "../plugins/fuzzy-search/fuzzy-search.vala"
			result = FALSE;
#line 78 "../plugins/fuzzy-search/fuzzy-search.vala"
			return result;
#line 448 "fuzzy-search.c"
		}
	}
#line 81 "../plugins/fuzzy-search/fuzzy-search.vala"
	result = FALSE;
#line 81 "../plugins/fuzzy-search/fuzzy-search.vala"
	return result;
#line 455 "fuzzy-search.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
	return _data1_;
#line 465 "fuzzy-search.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 475 "fuzzy-search.c"
		ScratchPluginsFuzzySearch* self;
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
		self = _data1_->self;
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
		_g_object_unref0 (_data1_->popover);
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
		_g_object_unref0 (self);
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
		g_slice_free (Block1Data, _data1_);
#line 485 "fuzzy-search.c"
	}
}

static void
__lambda27_ (Block1Data* _data1_,
             const gchar* filepath)
{
	ScratchPluginsFuzzySearch* self;
	ScratchFolderManagerFile* file = NULL;
	ScratchFolderManagerFile* _tmp0_;
	ScratchServicesDocument* doc = NULL;
	ScratchMainWindow* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	ScratchServicesDocument* _tmp6_;
	ScratchMainWindow* _tmp7_;
	ScratchFuzzySearchPopover* _tmp8_;
#line 93 "../plugins/fuzzy-search/fuzzy-search.vala"
	self = _data1_->self;
#line 93 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_return_if_fail (filepath != NULL);
#line 94 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp0_ = scratch_folder_manager_file_new (filepath);
#line 94 "../plugins/fuzzy-search/fuzzy-search.vala"
	file = _tmp0_;
#line 95 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp1_ = self->priv->window;
#line 95 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp2_ = scratch_main_window_get_actions (_tmp1_);
#line 95 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp3_ = _tmp2_;
#line 95 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp4_ = scratch_folder_manager_file_get_file (file);
#line 95 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp5_ = _tmp4_;
#line 95 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp6_ = scratch_services_document_new (_tmp3_, _tmp5_);
#line 95 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_object_ref_sink (_tmp6_);
#line 95 "../plugins/fuzzy-search/fuzzy-search.vala"
	doc = _tmp6_;
#line 97 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp7_ = self->priv->window;
#line 97 "../plugins/fuzzy-search/fuzzy-search.vala"
	scratch_main_window_open_document (_tmp7_, doc, TRUE, 0);
#line 98 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp8_ = _data1_->popover;
#line 98 "../plugins/fuzzy-search/fuzzy-search.vala"
	gtk_popover_popdown ((GtkPopover*) _tmp8_);
#line 93 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (doc);
#line 93 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (file);
#line 541 "fuzzy-search.c"
}

static void
___lambda27__scratch_fuzzy_search_popover_open_file (ScratchFuzzySearchPopover* _sender,
                                                     const gchar* filepath,
                                                     gpointer self)
{
#line 93 "../plugins/fuzzy-search/fuzzy-search.vala"
	__lambda27_ (self, filepath);
#line 551 "fuzzy-search.c"
}

static void
__lambda28_ (Block1Data* _data1_)
{
	ScratchPluginsFuzzySearch* self;
	ScratchFuzzySearchPopover* _tmp0_;
#line 101 "../plugins/fuzzy-search/fuzzy-search.vala"
	self = _data1_->self;
#line 101 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp0_ = _data1_->popover;
#line 101 "../plugins/fuzzy-search/fuzzy-search.vala"
	gtk_popover_popdown ((GtkPopover*) _tmp0_);
#line 565 "fuzzy-search.c"
}

static void
___lambda28__scratch_fuzzy_search_popover_close_search (ScratchFuzzySearchPopover* _sender,
                                                        gpointer self)
{
#line 101 "../plugins/fuzzy-search/fuzzy-search.vala"
	__lambda28_ (self);
#line 574 "fuzzy-search.c"
}

static void
scratch_plugins_fuzzy_search_fuzzy_find (ScratchPluginsFuzzySearch* self)
{
	Block1Data* _data1_;
	GSettings* settings = NULL;
	GSettings* _tmp0_;
	gchar** opened_folders = NULL;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint opened_folders_length1;
	gint _opened_folders_size_;
	gboolean _tmp4_ = FALSE;
	gchar** _tmp5_;
	gint _tmp5__length1;
	ScratchServicesFuzzySearchIndexer* _tmp7_;
	ScratchMainWindow* _tmp8_;
	ScratchFuzzySearchPopover* _tmp9_;
	ScratchFuzzySearchPopover* _tmp10_;
	ScratchFuzzySearchPopover* _tmp11_;
	ScratchFuzzySearchPopover* _tmp12_;
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_return_if_fail (self != NULL);
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
	_data1_->_ref_count_ = 1;
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
	_data1_->self = g_object_ref (self);
#line 85 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp0_ = g_settings_new ("io.elementary.code.folder-manager");
#line 85 "../plugins/fuzzy-search/fuzzy-search.vala"
	settings = _tmp0_;
#line 87 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp1_ = settings;
#line 87 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, "opened-folders");
#line 87 "../plugins/fuzzy-search/fuzzy-search.vala"
	opened_folders = _tmp3_;
#line 87 "../plugins/fuzzy-search/fuzzy-search.vala"
	opened_folders_length1 = _vala_array_length (_tmp2_);
#line 87 "../plugins/fuzzy-search/fuzzy-search.vala"
	_opened_folders_size_ = opened_folders_length1;
#line 88 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp5_ = opened_folders;
#line 88 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp5__length1 = opened_folders_length1;
#line 88 "../plugins/fuzzy-search/fuzzy-search.vala"
	if (_tmp5_ == NULL) {
#line 88 "../plugins/fuzzy-search/fuzzy-search.vala"
		_tmp4_ = TRUE;
#line 628 "fuzzy-search.c"
	} else {
		gchar** _tmp6_;
		gint _tmp6__length1;
#line 88 "../plugins/fuzzy-search/fuzzy-search.vala"
		_tmp6_ = opened_folders;
#line 88 "../plugins/fuzzy-search/fuzzy-search.vala"
		_tmp6__length1 = opened_folders_length1;
#line 88 "../plugins/fuzzy-search/fuzzy-search.vala"
		_tmp4_ = _tmp6__length1 < 1;
#line 638 "fuzzy-search.c"
	}
#line 88 "../plugins/fuzzy-search/fuzzy-search.vala"
	if (_tmp4_) {
#line 89 "../plugins/fuzzy-search/fuzzy-search.vala"
		opened_folders = (_vala_array_free (opened_folders, opened_folders_length1, (GDestroyNotify) g_free), NULL);
#line 89 "../plugins/fuzzy-search/fuzzy-search.vala"
		_g_object_unref0 (settings);
#line 89 "../plugins/fuzzy-search/fuzzy-search.vala"
		block1_data_unref (_data1_);
#line 89 "../plugins/fuzzy-search/fuzzy-search.vala"
		_data1_ = NULL;
#line 89 "../plugins/fuzzy-search/fuzzy-search.vala"
		return;
#line 652 "fuzzy-search.c"
	}
#line 92 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp7_ = self->priv->indexer;
#line 92 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp8_ = self->priv->window;
#line 92 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp9_ = scratch_fuzzy_search_popover_new (_tmp7_, _tmp8_);
#line 92 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_object_ref_sink (_tmp9_);
#line 92 "../plugins/fuzzy-search/fuzzy-search.vala"
	_data1_->popover = _tmp9_;
#line 93 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp10_ = _data1_->popover;
#line 93 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_signal_connect_data (_tmp10_, "open-file", (GCallback) ___lambda27__scratch_fuzzy_search_popover_open_file, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 101 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp11_ = _data1_->popover;
#line 101 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_signal_connect_data (_tmp11_, "close-search", (GCallback) ___lambda28__scratch_fuzzy_search_popover_close_search, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 102 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp12_ = _data1_->popover;
#line 102 "../plugins/fuzzy-search/fuzzy-search.vala"
	gtk_popover_popup ((GtkPopover*) _tmp12_);
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
	opened_folders = (_vala_array_free (opened_folders, opened_folders_length1, (GDestroyNotify) g_free), NULL);
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (settings);
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
	block1_data_unref (_data1_);
#line 84 "../plugins/fuzzy-search/fuzzy-search.vala"
	_data1_ = NULL;
#line 684 "fuzzy-search.c"
}

static void
scratch_plugins_fuzzy_search_real_deactivate (PeasActivatable* base)
{
	ScratchPluginsFuzzySearch * self;
	GtkEventControllerKey* _tmp0_;
	guint _tmp1_;
	ScratchMainWindow* _tmp2_;
	CodeSidebar* _tmp3_;
	GtkMenu* _tmp4_;
	GtkMenu* _tmp5_;
	GtkMenuItem* _tmp6_;
	GCancellable* _tmp7_;
#line 105 "../plugins/fuzzy-search/fuzzy-search.vala"
	self = (ScratchPluginsFuzzySearch*) base;
#line 106 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp0_ = self->priv->key_controller;
#line 106 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_signal_parse_name ("key-pressed", gtk_event_controller_key_get_type (), &_tmp1_, NULL, FALSE);
#line 106 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _scratch_plugins_fuzzy_search_on_window_key_press_event_gtk_event_controller_key_key_pressed, self);
#line 107 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp2_ = self->priv->window;
#line 107 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp3_ = _tmp2_->sidebar;
#line 107 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp4_ = code_sidebar_get_project_menu (_tmp3_);
#line 107 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp5_ = _tmp4_;
#line 107 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp6_ = self->priv->fuzzy_menuitem;
#line 107 "../plugins/fuzzy-search/fuzzy-search.vala"
	gtk_container_remove ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
#line 108 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp7_ = self->priv->cancellable;
#line 108 "../plugins/fuzzy-search/fuzzy-search.vala"
	if (_tmp7_ != NULL) {
#line 723 "fuzzy-search.c"
		GCancellable* _tmp8_;
#line 109 "../plugins/fuzzy-search/fuzzy-search.vala"
		_tmp8_ = self->priv->cancellable;
#line 109 "../plugins/fuzzy-search/fuzzy-search.vala"
		g_cancellable_cancel (_tmp8_);
#line 729 "fuzzy-search.c"
	}
}

ScratchPluginsFuzzySearch*
scratch_plugins_fuzzy_search_construct (GType object_type)
{
	ScratchPluginsFuzzySearch * self = NULL;
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	self = (ScratchPluginsFuzzySearch*) g_object_new (object_type, NULL);
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	return self;
#line 741 "fuzzy-search.c"
}

ScratchPluginsFuzzySearch*
scratch_plugins_fuzzy_search_new (void)
{
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	return scratch_plugins_fuzzy_search_construct (SCRATCH_PLUGINS_TYPE_FUZZY_SEARCH);
#line 749 "fuzzy-search.c"
}

static GObject*
scratch_plugins_fuzzy_search_real_get_object (PeasActivatable* base)
{
	GObject* result;
	ScratchPluginsFuzzySearch* self;
	GObject* _tmp0_;
	GObject* _tmp1_;
#line 10 "../plugins/fuzzy-search/fuzzy-search.vala"
	self = (ScratchPluginsFuzzySearch*) base;
#line 10 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp0_ = self->priv->_object;
#line 10 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 10 "../plugins/fuzzy-search/fuzzy-search.vala"
	result = _tmp1_;
#line 10 "../plugins/fuzzy-search/fuzzy-search.vala"
	return result;
#line 769 "fuzzy-search.c"
}

static void
scratch_plugins_fuzzy_search_real_set_object (PeasActivatable* base,
                                              GObject* value)
{
	ScratchPluginsFuzzySearch* self;
	GObject* old_value;
#line 10 "../plugins/fuzzy-search/fuzzy-search.vala"
	self = (ScratchPluginsFuzzySearch*) base;
#line 10 "../plugins/fuzzy-search/fuzzy-search.vala"
	old_value = scratch_plugins_fuzzy_search_real_get_object (base);
#line 10 "../plugins/fuzzy-search/fuzzy-search.vala"
	if (old_value != value) {
#line 784 "fuzzy-search.c"
		GObject* _tmp0_;
#line 10 "../plugins/fuzzy-search/fuzzy-search.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 10 "../plugins/fuzzy-search/fuzzy-search.vala"
		_g_object_unref0 (self->priv->_object);
#line 10 "../plugins/fuzzy-search/fuzzy-search.vala"
		self->priv->_object = _tmp0_;
#line 10 "../plugins/fuzzy-search/fuzzy-search.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_plugins_fuzzy_search_properties[SCRATCH_PLUGINS_FUZZY_SEARCH_OBJECT_PROPERTY]);
#line 794 "fuzzy-search.c"
	}
#line 10 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (old_value);
#line 798 "fuzzy-search.c"
}

static void
scratch_plugins_fuzzy_search_class_init (ScratchPluginsFuzzySearchClass * klass,
                                         gpointer klass_data)
{
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	scratch_plugins_fuzzy_search_parent_class = g_type_class_peek_parent (klass);
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_type_class_adjust_private_offset (klass, &ScratchPluginsFuzzySearch_private_offset);
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_scratch_plugins_fuzzy_search_get_property;
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_scratch_plugins_fuzzy_search_set_property;
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	G_OBJECT_CLASS (klass)->finalize = scratch_plugins_fuzzy_search_finalize;
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_PLUGINS_FUZZY_SEARCH_OBJECT_PROPERTY, scratch_plugins_fuzzy_search_properties[SCRATCH_PLUGINS_FUZZY_SEARCH_OBJECT_PROPERTY] = g_param_spec_object ("object", "object", "object", G_TYPE_OBJECT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 817 "fuzzy-search.c"
}

static void
scratch_plugins_fuzzy_search_peas_activatable_interface_init (PeasActivatableInterface * iface,
                                                              gpointer iface_data)
{
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	scratch_plugins_fuzzy_search_peas_activatable_parent_iface = g_type_interface_peek_parent (iface);
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	iface->update_state = (void (*) (PeasActivatable*)) scratch_plugins_fuzzy_search_real_update_state;
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	iface->activate = (void (*) (PeasActivatable*)) scratch_plugins_fuzzy_search_real_activate;
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	iface->deactivate = (void (*) (PeasActivatable*)) scratch_plugins_fuzzy_search_real_deactivate;
#line 832 "fuzzy-search.c"
}

static void
scratch_plugins_fuzzy_search_instance_init (ScratchPluginsFuzzySearch * self,
                                            gpointer klass)
{
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	self->priv = scratch_plugins_fuzzy_search_get_instance_private (self);
#line 15 "../plugins/fuzzy-search/fuzzy-search.vala"
	self->priv->window = NULL;
#line 843 "fuzzy-search.c"
}

static void
scratch_plugins_fuzzy_search_finalize (GObject * obj)
{
	ScratchPluginsFuzzySearch * self;
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_PLUGINS_TYPE_FUZZY_SEARCH, ScratchPluginsFuzzySearch);
#line 10 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (self->priv->_object);
#line 14 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (self->priv->indexer);
#line 15 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (self->priv->window);
#line 16 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (self->priv->plugins);
#line 17 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 18 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (self->priv->fuzzy_menuitem);
#line 19 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	G_OBJECT_CLASS (scratch_plugins_fuzzy_search_parent_class)->finalize (obj);
#line 868 "fuzzy-search.c"
}

GType
scratch_plugins_fuzzy_search_get_type (void)
{
	return scratch_plugins_fuzzy_search_type_id;
}

GType
scratch_plugins_fuzzy_search_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScratchPluginsFuzzySearchClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scratch_plugins_fuzzy_search_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScratchPluginsFuzzySearch), 0, (GInstanceInitFunc) scratch_plugins_fuzzy_search_instance_init, NULL };
	static const GInterfaceInfo peas_activatable_info = { (GInterfaceInitFunc) scratch_plugins_fuzzy_search_peas_activatable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	scratch_plugins_fuzzy_search_type_id = g_type_module_register_type (module, peas_extension_base_get_type (), "ScratchPluginsFuzzySearch", &g_define_type_info, 0);
	g_type_module_add_interface (module, scratch_plugins_fuzzy_search_type_id, peas_activatable_get_type (), &peas_activatable_info);
	ScratchPluginsFuzzySearch_private_offset = sizeof (ScratchPluginsFuzzySearchPrivate);
	return scratch_plugins_fuzzy_search_type_id;
}

static void
_vala_scratch_plugins_fuzzy_search_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	ScratchPluginsFuzzySearch * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_PLUGINS_TYPE_FUZZY_SEARCH, ScratchPluginsFuzzySearch);
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	switch (property_id) {
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
		case SCRATCH_PLUGINS_FUZZY_SEARCH_OBJECT_PROPERTY:
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
		g_value_take_object (value, scratch_plugins_fuzzy_search_real_get_object ((PeasActivatable*) self));
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
		break;
#line 904 "fuzzy-search.c"
		default:
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
		break;
#line 910 "fuzzy-search.c"
	}
}

static void
_vala_scratch_plugins_fuzzy_search_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	ScratchPluginsFuzzySearch * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_PLUGINS_TYPE_FUZZY_SEARCH, ScratchPluginsFuzzySearch);
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
	switch (property_id) {
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
		case SCRATCH_PLUGINS_FUZZY_SEARCH_OBJECT_PROPERTY:
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
		scratch_plugins_fuzzy_search_real_set_object ((PeasActivatable*) self, g_value_get_object (value));
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
		break;
#line 930 "fuzzy-search.c"
		default:
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../plugins/fuzzy-search/fuzzy-search.vala"
		break;
#line 936 "fuzzy-search.c"
	}
}

void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* objmodule = NULL;
	PeasObjectModule* _tmp0_;
#line 115 "../plugins/fuzzy-search/fuzzy-search.vala"
	g_return_if_fail (module != NULL);
#line 115 "../plugins/fuzzy-search/fuzzy-search.vala"
	scratch_plugins_fuzzy_search_register_type (module);
#line 115 "../plugins/fuzzy-search/fuzzy-search.vala"
	scratch_services_fuzzy_finder_register_type (module);
#line 115 "../plugins/fuzzy-search/fuzzy-search.vala"
	scratch_services_fuzzy_finder_recursive_finder_register_type (module);
#line 115 "../plugins/fuzzy-search/fuzzy-search.vala"
	scratch_services_fuzzy_search_indexer_register_type (module);
#line 115 "../plugins/fuzzy-search/fuzzy-search.vala"
	scratch_services_search_project_register_type (module);
#line 115 "../plugins/fuzzy-search/fuzzy-search.vala"
	scratch_fuzzy_search_popover_register_type (module);
#line 115 "../plugins/fuzzy-search/fuzzy-search.vala"
	file_item_register_type (module);
#line 115 "../plugins/fuzzy-search/fuzzy-search.vala"
	indexer_message_register_type (module);
#line 115 "../plugins/fuzzy-search/fuzzy-search.vala"
	initial_index_request_register_type (module);
#line 115 "../plugins/fuzzy-search/fuzzy-search.vala"
	project_update_register_type (module);
#line 115 "../plugins/fuzzy-search/fuzzy-search.vala"
	search_result_register_type (module);
#line 116 "../plugins/fuzzy-search/fuzzy-search.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
#line 116 "../plugins/fuzzy-search/fuzzy-search.vala"
	objmodule = _tmp0_;
#line 117 "../plugins/fuzzy-search/fuzzy-search.vala"
	peas_object_module_register_extension_type (objmodule, peas_activatable_get_type (), SCRATCH_PLUGINS_TYPE_FUZZY_SEARCH);
#line 115 "../plugins/fuzzy-search/fuzzy-search.vala"
	_g_object_unref0 (objmodule);
#line 977 "fuzzy-search.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

